#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_caltabconvert import caltabconvert
from task_caltabconvert import casalog

class caltabconvert_pg_:
    __name__ = "caltabconvert"

    def __init__(self) :
       self.__bases__ = (caltabconvert_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, caltabold=None,vis=None,ptype=None,caltabnew=None,):

        """Convert old-style caltables into new-style caltables.\n
    This task converts old-style (up to CASA 3.3.0) caltables into new-style 
    (CASA 3.4.0 and later) caltables. It is provided as a convenience and 
    is strictly temporary. The information transferred should be enough 
    for most calibration purposes. BPOLY and GSPLINE versions are not 
    supported. Only simple bugs will be fixed. If there are other issues, 
    it is suggested that a new-style caltable be created directly.

    Arguments:

    caltabold -- Name of the old-style caltable.
    default: none
    example: caltabold='gronk.g0'

    vis -- Name of the visibility file (MS) associated with the old-style
        caltable.
    default: none
    example: vis='blurp.ms'

    ptype -- Type of data in the new-format caltable.
    default: "complex"; allowed values: "complex" or "float"
    example: ptype="complex"

    NB: The old-style caltables do not have this information, so it is
    imperative that users get it correct.  "complex" refers to caltables that
    have complex gains (e.g., produced by gaincal, bpcal, etc.).  "float" refers
    to caltables that real numbers such as delays (e.g., produced by gencal).

    caltabnew -- Name of the new-style caltable.
    default: "" --> the suffix ".new" is appended to the name of the old-style
        caltable
    example: caltabold='gronk_new.g0'
  
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'caltabconvert'
        myf['taskname'] = 'caltabconvert'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['caltabold'] = caltabold = myf['caltabold']
            myparams['vis'] = vis = myf['vis']
            myparams['ptype'] = ptype = myf['ptype']
            myparams['caltabnew'] = caltabnew = myf['caltabnew']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['caltabold'] = caltabold
        mytmp['vis'] = vis
        mytmp['ptype'] = ptype
        mytmp['caltabnew'] = caltabnew
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'caltabconvert.xml')

        casalog.origin('caltabconvert')
        if not trec.has_key('caltabconvert') or not casac.utils().verify(mytmp, trec['caltabconvert']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: caltabconvert           #####')
          casalog.post('')
          result = caltabconvert(caltabold, vis, ptype, caltabnew)
          casalog.post('')
          casalog.post('##### End Task: caltabconvert           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('caltabconvert', 'caltabconvert.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'caltabconvert'
	     casalog.post('An error occurred running task '+tname+'.', 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('caltabconvert', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['caltabold']  = ''
        a['vis']  = ''
        a['ptype']  = 'complex'
        a['caltabnew']  = ''


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='caltabconvert', subkey=None):
        desc={'caltabconvert': 'Convert old-style caltables into new-style caltables.\n',
               'caltabold': 'Name of the old-style caltable.',
               'vis': 'Name of the visibility file (MS) associated with the old-style caltable.',
               'ptype': 'Type of data in the new-format caltable ("complex" or "float"; default is "complex").',
               'caltabnew': 'Name of the new-style caltable.  If not specified, the suffix ".new" is appended to the name of old-style caltable.',

              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['caltabold']  = ''
        a['vis']  = ''
        a['ptype']  = 'complex'
        a['caltabnew']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
caltabconvert_pg = caltabconvert_pg_()
