#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_delmod import delmod
from task_delmod import casalog

class delmod_pg_:
    __name__ = "delmod"

    def __init__(self) :
       self.__bases__ = (delmod_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,otf=None,field=None,scr=None,):

        """Deletes model representations in the MS

      This utility task is to be used to delete the model visibility
      data representations in the MS.  The 'otf' representation is
      the new (as of v3.4) 'scratch-less' model data, stored as
      keywords in the MS header containing model data formation
      instructions.  It is generated by the setjy, ft, and clean
      tasks (usescratch=F), and if present, overrides the 
      old-fashioned MODEL_DATA column (if present).  If a user
      wishes to use the MODEL_DATA column _after_ having operated
      with the 'otf' representation, this task can be used
      to delete the 'otf' represenatation to make the MODEL_DATA
      column visible.  (Create the MODEL_DATA column by using
      usescratch=T in setjy, ft, or clean; or by running the
      clearcal task with addmodel=T.)

      If otf=T, specific fields can be selected for deletion
      using standard field selection semantics.  If field='',
      all fields' models will be deleted.

      For convenience, this method also provides a means for
      deleting the MODEL_DATA column by setting scr=T.  Note
      that it is not possible to delete the MODEL_DATA column
      per field.

      If otf=F and scr=F, delmod will provide a listing
      of the header field records.


 
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'delmod'
        myf['taskname'] = 'delmod'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['otf'] = otf = myf['otf']
            myparams['field'] = field = myf['field']
            myparams['scr'] = scr = myf['scr']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['otf'] = otf
        mytmp['field'] = field
        mytmp['scr'] = scr
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'delmod.xml')

        casalog.origin('delmod')
        if not trec.has_key('delmod') or not casac.utils().verify(mytmp, trec['delmod']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: delmod           #####')
          casalog.post('')
          result = delmod(vis, otf, field, scr)
          casalog.post('')
          casalog.post('##### End Task: delmod           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('delmod', 'delmod.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'delmod'
	     casalog.post('An error occurred running task '+tname+'.', 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('delmod', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['otf']  = True
        a['scr']  = False

        a['otf'] = {
                    0:odict([{'value':True}, {'field':''}]), 
                    1:{'value':False}}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='delmod', subkey=None):
        desc={'delmod': 'Deletes model representations in the MS',
               'vis': 'Name of input visibility file (MS)',
               'otf': 'Delete the on-the-fly model data keywords',
               'field': 'Select field using field id(s) or field name(s)',
               'scr': 'Delete the MODEL_DATA scr col (if it exists)',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['otf']  = True
        a['field']  = ''
        a['scr']  = False

        if a.has_key(paramname) :
	      return a[paramname]
delmod_pg = delmod_pg_()
