#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_flagmanager import flagmanager
from task_flagmanager import casalog

class flagmanager_pg_:
    __name__ = "flagmanager"

    def __init__(self) :
       self.__bases__ = (flagmanager_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,mode=None,versionname=None,oldname=None,comment=None,merge=None,):

        """Enable list, save, restore, delete and rename flag version files.


        These flag version files are copies of the flag column for a
        measurement set.  They can be restored to the data set to obtain
        a previous flag version.  On running importvla, a flag
        version call 'Original' is automatically produced.  It is wise to
        save a flagversion at the beginning or after serious editing.    

        Keyword arguments:
        vis -- Name of input visibility file
                default: none. example: vis='ngc5921.ms'
        mode -- Flag version operation
                default: 'list'; to list existing flagtables
                'save' will save flag column from vis to a specified flag file
                'restore' will place the specified flag file into vis
                'delete' will delete specified flag file
                'rename' will rename a specified flag file
        versionname -- Flag version name
                default: none; example: versionname='original_data'
                No imbedded blanks in the versionname
        comment -- Short description of a versionname, when mode is 'save' or 'rename'
                default: ''; example: comment='Clip above 1.85'
                comment = versionname
        oldname -- When mode='rename', the flag file to rename
        merge -- Merge operation
                Options: 'or','and', but not recommended for now.

 
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'flagmanager'
        myf['taskname'] = 'flagmanager'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['mode'] = mode = myf['mode']
            myparams['versionname'] = versionname = myf['versionname']
            myparams['oldname'] = oldname = myf['oldname']
            myparams['comment'] = comment = myf['comment']
            myparams['merge'] = merge = myf['merge']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['mode'] = mode
        mytmp['versionname'] = versionname
        mytmp['oldname'] = oldname
        mytmp['comment'] = comment
        mytmp['merge'] = merge
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'flagmanager.xml')

        casalog.origin('flagmanager')
        if not trec.has_key('flagmanager') or not casac.utils().verify(mytmp, trec['flagmanager']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: flagmanager           #####')
          casalog.post('')
          result = flagmanager(vis, mode, versionname, oldname, comment, merge)
          casalog.post('')
          casalog.post('##### End Task: flagmanager           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('flagmanager', 'flagmanager.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'flagmanager'
	     casalog.post('An error occurred running task '+tname+'.', 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('flagmanager', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['mode']  = 'list'

        a['mode'] = {
                    0:{'value':'list'}, 
                    1:odict([{'value':'save'}, {'versionname':''}, {'comment':''}, {'merge':'replace'}]), 
                    2:odict([{'value':'restore'}, {'versionname':''}, {'merge':'replace'}]), 
                    3:odict([{'value':'delete'}, {'versionname':''}]), 
                    4:odict([{'value':'rename'}, {'oldname':''}, {'versionname':''}, {'comment':''}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='flagmanager', subkey=None):
        desc={'flagmanager': 'Enable list, save, restore, delete and rename flag version files.',
               'vis': 'Name of input visibility file (MS)',
               'mode': 'Operation: list, save, restore, delete, rename',
               'versionname': 'Flag version name',
               'oldname': 'Flag version to rename',
               'comment': 'Short description of a versionname',
               'merge': 'Merge option: replace will save or over-write the flags',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['mode']  = 'list'
        a['versionname']  = ''
        a['oldname']  = ''
        a['comment']  = ''
        a['merge']  = 'replace'

        if a.has_key(paramname) :
	      return a[paramname]
flagmanager_pg = flagmanager_pg_()
