#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
#from taskmanager import tm
import task_hanningsmooth
def hanningsmooth(vis='', datacolumn='all', outputvis=''):

        """Hanning smooth frequency channel data to remove Gibbs ringing

    This function Hanning smoothes the frequency channels with
    a weighted running average. The weights are 0.5 for the central 
    channel and 0.25 for each of the two adjacent channels. The first 
    and last channels are flagged.
    Inclusion of a flagged value in an average causes that data value
    to be flagged. 
    If an 'outputvis' filename is given, the task will copy the input file to the 
    output file name first, including all columns that are present in the input MS. 
    After that step it will smooth the column(s) as requested in the 'datacolumn' parameter. 
    Alternatively, if no 'outputvis' is specified, hanningsmooth will work directly on the 
    input visibility file. 
    If the 'CORRECTED' data column is requested for an MS that does not contain this column, 
    it will be filled from the 'DATA' column and then smoothed.
    
    WARNING: by default, all visibility columns will be smoothed. This will 
             modify the DATA column of the output MS in order to make sure that
             later gaincal will work on the smoothed data, e.g. as part of self-cal.

    Keyword arguments:
    vis -- Name of input visibility file (MS)
           default: none; example: vis='ngc5921.ms'
    datacolumn -- the name of the MS column to be Hanning smoothed
                  default='all'; example: datacolumn='corrected'
                  options: 'corrected', 'data', 'all'
    outputvis -- name of the output visibility file (MS)
                 default=none (write to the input MS); example: outputvis='ngc5921_src.ms'

    hanningsmooth(vis='ngc4852.ms', datacolumn='data', outputvis='ngc4852-hs.ms')		 


 
        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['datacolumn'] = datacolumn
        mytmp['outputvis'] = outputvis
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'hanningsmooth.xml')

        casalog.origin('hanningsmooth')
        if trec.has_key('hanningsmooth') and casac.utils().verify(mytmp, trec['hanningsmooth']) :
	    result = task_hanningsmooth.hanningsmooth(vis, datacolumn, outputvis)

	else :
	  result = False
        return result
