#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
#from taskmanager import tm
import task_importfitsidi
def importfitsidi(fitsidifile=[''], vis=''):

        """Convert a FITS-IDI file to a CASA visibility data set
	If several files are given, they will be concatenated into one MS.

        Keyword arguments:
        fitsidifile -- Name(s) of input FITS-IDI file(s)
                default: none; must be supplied 
		example='3C273XC1.IDI'
		example=['3C273XC1.IDI1','3C273XC1.IDI2'] 
        vis -- Name of output visibility file (MS)
                default: none; example: vis='3C273XC1.ms'
        async --  Run asynchronously
               default = false; do not run asychronously

 
        """
        if type(fitsidifile)==str: fitsidifile=[fitsidifile]

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['fitsidifile'] = fitsidifile
        mytmp['vis'] = vis
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'importfitsidi.xml')

        casalog.origin('importfitsidi')
        if trec.has_key('importfitsidi') and casac.utils().verify(mytmp, trec['importfitsidi']) :
	    result = task_importfitsidi.importfitsidi(fitsidifile, vis)

	else :
	  result = False
        return result
