#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_importuvfits import importuvfits
from task_importuvfits import casalog

class importuvfits_pg_:
    __name__ = "importuvfits"

    def __init__(self) :
       self.__bases__ = (importuvfits_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, fitsfile=None,vis=None,antnamescheme=None,):

        """Convert a UVFITS file to a CASA visibility data set
        Convert a UVFITS file to a CASA visibility data set:

        Keyword arguments:
        fitsfile -- Name of input UV FITS file
                default = none; example='3C273XC1.fits'
        vis -- Name of output visibility file (MS)
                default = none; example: vis='3C273XC1.ms'
	antnamescheme -- Naming scheme for VLA/JVLA/CARMA antennas
                default = old;
                  old: Antenna name is a number, '04'
                       This option exists for backwards compatibility
                       but can lead to ambiguous results when antenna
                       indices are used for data selection.
                  new: Antenna name is not a number, e.g., 'VA04' or 'EA04'
                       With this scheme, data selection via
                       antenna names and indices is non-ambiguous.
        async --  Run asynchronously
               default = false; do not run asychronously

	Note: Don't forget to flag autocorrections using
	   taskname flagdata, autocorr = true

 
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'importuvfits'
        myf['taskname'] = 'importuvfits'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['fitsfile'] = fitsfile = myf['fitsfile']
            myparams['vis'] = vis = myf['vis']
            myparams['antnamescheme'] = antnamescheme = myf['antnamescheme']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['fitsfile'] = fitsfile
        mytmp['vis'] = vis
        mytmp['antnamescheme'] = antnamescheme
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'importuvfits.xml')

        casalog.origin('importuvfits')
        if not trec.has_key('importuvfits') or not casac.utils().verify(mytmp, trec['importuvfits']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: importuvfits           #####')
          casalog.post('')
          result = importuvfits(fitsfile, vis, antnamescheme)
          casalog.post('')
          casalog.post('##### End Task: importuvfits           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('importuvfits', 'importuvfits.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'importuvfits'
	     casalog.post('An error occurred running task '+tname+'.', 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('importuvfits', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['fitsfile']  = ''
        a['vis']  = ''
        a['antnamescheme']  = 'old'


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='importuvfits', subkey=None):
        desc={'importuvfits': 'Convert a UVFITS file to a CASA visibility data set',
               'fitsfile': 'Name of input UV FITS file',
               'vis': 'Name of output visibility file (MS)',
               'antnamescheme': 'VLA/EVLA/CARMA only; \'new\' or \'old\'; \'VA04\' or \'04\' for VLA ant 4',

              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['fitsfile']  = ''
        a['vis']  = ''
        a['antnamescheme']  = 'old'

        if a.has_key(paramname) :
	      return a[paramname]
importuvfits_pg = importuvfits_pg_()
