#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
#from taskmanager import tm
import task_initweights
def initweights(vis='', dobt=True, dowtsp=False):

        """Initializes weight information in the MS

      This task provides for initialization of the weight information
      in the MS.  For ALMA and EVLA data, it should not generally be
      necessary to use this task, as the weight information should 
      have been initialized fill time (v4.2.2 and later).

      If dobt=T, then the initialization will be according to the
      channel bandwidth and integration time.  This is formally
      corrected for normalized visibility data (e.g., ALMA).  For
      the EVLA, this is correct if switched-power and bandpass 
      calibration will later be applied.

      If dobt=F, then the initialization value will be unity (1.0).
      This is ok if the channel bandwidth and integration time are uniform
      for all spectral windows and scans.  If this condition is not
      met, then there will be disproprotionate weights within the MS.
    
      If dowtsp=T, then the WEIGHT_SPECTRUM colum will also be
      initialized (uniformly in channel).  If necessary, the 
      WEIGHT_SPECTRUM column will be created.  Use of the 
      WEIGHT_SPECTRUM column is only meaningful
      for ALMA data which will be calibrated with channelized
      Tsys information, or if the weights will be manually set
      in a channelized manner after calibration (a task for this
      is currently under development).


 
        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['dobt'] = dobt
        mytmp['dowtsp'] = dowtsp
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'initweights.xml')

        casalog.origin('initweights')
        if trec.has_key('initweights') and casac.utils().verify(mytmp, trec['initweights']) :
	    result = task_initweights.initweights(vis, dobt, dowtsp)

	else :
	  result = False
        return result
