#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from types import * 
from task_sdbaselineold import sdbaselineold
class sdbaselineold_cli_:
    __name__ = "sdbaselineold"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (sdbaselineold_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'infile':None, 'antenna':None, 'fluxunit':None, 'telescopeparm':None, 'specunit':None, 'restfreq':None, 'frame':None, 'doppler':None, 'scanlist':None, 'field':None, 'iflist':None, 'pollist':None, 'tau':None, 'masklist':None, 'maskmode':None, 'thresh':None, 'avg_limit':None, 'edge':None, 'blfunc':None, 'order':None, 'npiece':None, 'applyfft':None, 'fftmethod':None, 'fftthresh':None, 'addwn':None, 'rejwn':None, 'clipthresh':None, 'clipniter':None, 'verify':None, 'verbose':None, 'bloutput':None, 'blformat':None, 'showprogress':None, 'minnrow':None, 'outfile':None, 'outform':None, 'overwrite':None, 'plotlevel':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, infile=None, antenna=None, fluxunit=None, telescopeparm=None, specunit=None, restfreq=None, frame=None, doppler=None, scanlist=None, field=None, iflist=None, pollist=None, tau=None, masklist=None, maskmode=None, thresh=None, avg_limit=None, edge=None, blfunc=None, order=None, npiece=None, applyfft=None, fftmethod=None, fftthresh=None, addwn=None, rejwn=None, clipthresh=None, clipniter=None, verify=None, verbose=None, bloutput=None, blformat=None, showprogress=None, minnrow=None, outfile=None, outform=None, overwrite=None, plotlevel=None, ):

        """ASAP SD task: fit/subtract a spectral baseline 

	Detailed Description: 
ASAP SD calibration task (based on the ALMATST5 recommendations):
        fit/subtract a spectral baseline 

        Modified (change default value of addwn from [] to [0]) 2012-02-16 WK
        Modified (add parameters applyfft,fftmethod,fftthresh,addwn,rejwn) 2011-06-07 WK
        Modified (delete parameters nwave,maxwavelength) 2011-06-07 WK
        Modified (rename parameter masking to maskmode) 2011-03-10 WK
        Modified (change parameter order to blfunc's subparam) 2011-02-25 WK
        Modified (add parameters blfunc,npiece,clipthresh,clipniter) 2011-02-25 WK
        Modified (rename parameters blmode,blpoly to masking,order, respectively) 2011-02-25 WK
        Modified (rename parameter interactive to verify) 2008-11-20 KS
        Modified (+interactive mask) 2008-08-20 KS
        Task Version 2008-01-28 TT
        split and modified from Task Version 2007-03-04 STM

	Arguments :
		infile:	name of input SD dataset
		   Default Value: 

		antenna:	antenna name or id (only effective for MS input)
		   Default Value: 0

		fluxunit:	units for line flux (K,Jy) (''=current)
		   Default Value: 

		telescopeparm:	param of telescope for flux conversion
		   Default Value: 

		specunit:	units for spectral axis (channel,km/s,GHz)
		   Default Value: 
		   Allowed Values:
				
				channel
				km/s
				GHz
				MHz
				kHz
				Hz

		restfreq:	rest frequency (default unit: Hz)
		   Default Value: 

		frame:	frequency reference frame, e.g. LSRK (''=current)
		   Default Value: 

		doppler:	doppler convention, e.g. RADIO (''=current)
		   Default Value: 

		scanlist:	list of scans to use (e.g. [1,2,3,4])
		   Default Value: 

		field:	string for selection by source name
		   Default Value: 

		iflist:	list of IF ids to select (e.g. [0,1])
		   Default Value: 

		pollist:	list of polarization ids to select (e.g. [0,1])
		   Default Value: 

		tau:	atmospheric optical depth for correction
		   Default Value: 0.0

		masklist:	list or string of mask regions to INCLUDE in BASELINE fit
		   Default Value: 

		maskmode:	mode of setting additional channel masks
		   Default Value: 
		   Allowed Values:
				auto
				list
				interact

		thresh:	S/N threshold for linefinder
		   Default Value: 5.0

		avg_limit:	channel averaging for broad lines
		   Default Value: 4

		edge:	channels to drop at beginning and end of spectrum
		   Default Value: 0

		blfunc:	baseline model function
		   Default Value: poly
		   Allowed Values:
				poly
				chebyshev
				cspline
				sinusoid

		order:	order of baseline polynomial
		   Default Value: 5

		npiece:	number of element polynomials of spline
		   Default Value: 2

		applyfft:	automatically set wave numbers of sinusoids
		   Default Value: True

		fftmethod:	method for automatically set wave numbers of sinusoids
		   Default Value: fft

		fftthresh:	threshold to select wave numbers of sinusoids
		   Default Value: 3.0

		addwn:	additional wave numbers to use
		   Default Value: 0

		rejwn:	wave numbers NOT to use
		   Default Value: 

		clipthresh:	clipping threshold for iterative fitting
		   Default Value: 3.0

		clipniter:	maximum iteration number
		   Default Value: 0

		verify:	interactively verify the results of baseline fitting for each spectrum. (only for blfunc="poly")
		   Default Value: False

		verbose:	output fitting results to logger
		   Default Value: True

		bloutput:	output fitting results to a text file
		   Default Value: True

		blformat:	format of the text file specified with bloutput
		   Default Value: 

		showprogress:	show progress status for large data
		   Default Value: True

		minnrow:	minimum number of input spectra to show progress status
		   Default Value: 1000

		outfile:	output file name
		   Default Value: 

		outform:	output file format (ASCII,MS,SDFITS,ASAP)
		   Default Value: ASAP
		   Allowed Values:
				ASCII
				ascii
				MS
				ms
				MS2
				ms2
				SDFITS
				sdfits
				ASAP
				asap

		overwrite:	overwrite the output file if already exists
		   Default Value: False

		plotlevel:	plot results (0=none,1+=some,&lt;0=hardcopy)
		   Default Value: 0

	Returns: void

	Example :

        Keyword arguments:
        infile -- name of input SD dataset
        antenna -- antenna name or id (only effective for MS input). 
        fluxunit -- units for line flux
                options: 'K','Jy',''
                default: '' (keep current fluxunit)
                WARNING: For GBT data, see description below.
            >>> fluxunit expandable parameter
                 telescopeparm -- the telescope characteristics
                        options: (str) name or (list) list of gain info
                        default: '' (none set)
                        example: if telescopeparm='', it tries to get the telescope
                                 name from the data.
                                 Full antenna parameters (diameter,ap.eff.) known
                                 to ASAP are
                                 'ATPKSMB', 'ATPKSHOH', 'ATMOPRA', 'DSS-43',
                                 'CEDUNA','HOBART'. For GBT, it fixes default fluxunit
                                 to 'K' first then convert to a new fluxunit.
                                 telescopeparm=[104.9,0.43] diameter(m), ap.eff.
                                 telescopeparm=[0.743] gain in Jy/K
                                 telescopeparm='FIX' to change default fluxunit
                                 see description below
        specunit -- units for spectral axis
                options: (str) 'channel','km/s','GHz','MHz','kHz','Hz',''
                default: '' (=current)
                example: this will be the units for masklist
            >>> specunit expandable parameters
                 restfreq -- rest frequency
                         available type includes float, int, string, list of float, 
                         list of int, list of string, and list of dictionary. the 
                         default unit of restfreq in case of float, int, or string 
                         without unit is Hz. string input can be a value only 
                         (treated as Hz) or a value followed by unit for which 'GHz',
                         'MHz','kHz',and 'Hz' are available. 
                         a list can be used to set different rest frequencies for 
                         each IF. the length of list input must be nIF. dictionary 
                         input should be a pair of molecule name and frequency with 
                         keys of 'name' and 'value', respectively. values in the 
                         dictionary input follows the same manner as for single 
                         float or string input. 
                         example: 345.796
                                  '1420MHz'
                                  [345.8, 347.0, 356.7]
                                  ['345.8MHz', '347.0MHz', '356.7MHz']
                                  [{'name':'CO','value':345}]
        frame -- frequency frame for spectral axis
                options: (str) 'LSRK','REST','TOPO','LSRD','BARY',
                         'GEO','GALACTO','LGROUP','CMB'
                default: currently set frame in scantable
                WARNING: frame='REST' not yet implemented
        doppler -- doppler mode
                options: (str) 'RADIO','OPTICAL','Z','BETA','GAMMA'
                default: currently set doppler in scantable
        scanlist -- list of scan numbers to process
                default: [] (use all scans)
                example: [21,22,23,24]
                this selection is in addition to field, iflist, and pollist
        field -- selection string for selecting scans by name
                default: '' (no name selection)
                example: 'FLS3a*'
                this selection is in addition to scanlist, iflist, and pollist
        iflist -- list of IF id numbers to select
                default: [] (use all IFs)
                example: [15]
                this selection is in addition to scanlist, field, and pollist
        pollist -- list of polarization id numbers to select
                default: [] (use all polarizations)
                example: [1]
                this selection is in addition to scanlist, field, and iflist
        tau -- atmospheric optical depth
                default: 0.0 (no correction)
        masklist -- list or string of mask regions to INCLUDE in BASELINE fit
                    a string masklist allows per IF selection of channels.
                default: [] (entire spectrum)
                example: [[1000,3000],[5000,7000]]
                         '0:1000~3000;5000~7000, 1:200~350;450~600'
                         when maskmode is 'auto' or 'interact', this mask 
                         will be applied first before fitting as base mask
        maskmode -- mode of setting additional channel masks
                options: (str) 'auto','list','interact'
                default: 'auto'
                example: maskmode='auto' runs linefinder to detect line regions 
                         to be excluded from fitting. this mode requires three 
                         expandable parameters: thresh, avg_limit, and edge.
                         USE WITH CARE! May need to tweak the expandable parameters.
                         maskmode='list' uses the given masklist only: no additional 
                         masks applied.
                         maskmode='interact' allows users to manually modify the 
                         mask regions by dragging mouse on the spectrum plotter GUI.
                         use LEFT or RIGHT button to add or delete regions, 
                         respectively.
               
            >>> maskmode expandable parameters
                 thresh -- S/N threshold for linefinder
                         default: 5
                         example: a single channel S/N ratio above which the channel is
                                  considered to be a detection
                 avg_limit -- channel averaging for broad lines
                         default: 4
                         example: a number of consecutive channels not greater than
                                  this parameter can be averaged to search for broad lines
                 edge -- channels to drop at beginning and end of spectrum
                         default: 0
                         example: [1000] drops 1000 channels at beginning AND end
                                  [1000,500] drops 1000 from beginning and 500 from end
                 Note: For bad baselines threshold should be increased,
                 and avg_limit decreased (or even switched off completely by
                 setting this parameter to 1) to avoid detecting baseline
                 undulations instead of real lines.
        blfunc -- baseline model function
                options: (str) 'poly','chebyshev','cspline','sinusoid'
                default: 'poly'
                example: blfunc='poly' uses a single polynomial line of 
                         any order which should be given as an expandable 
                         parameter 'order' to fit baseline. 
                         blfunc='chebyshev' uses Chebyshev polynomials. 
                         blfunc='cspline' uses a cubic spline function, a piecewise 
                         cubic polynomial having C2-continuity (i.e., the second 
                         derivative is continuous at the joining points). 
                         blfunc='sinusoid' uses a combination of sinusoidal curves. 
            >>> blfunc expandable parameters
                 order -- order of baseline polynomial
                         options: (int) (<0 turns off baseline fitting)
                         default: 5
                         example: typically in range 2-9 (higher values
                                  seem to be needed for GBT)
                 npiece -- number of the element polynomials of cubic spline curve
                         options: (int) (<0 turns off baseline fitting)
                         default: 2
                 applyfft -- automatically set wave numbers of sinusoidal functions 
                         for fitting by applying some method like FFT.
                         options: (bool) True, False
                         default: True
                 fftmethod -- method to be used when applyfft=True. Now only 
                         'fft' is available and it is the default.
                 fftthresh -- threshold to select wave numbers to be used for 
                         sinusoidal fitting. both (float) and (str) accepted.
                         given a float value, the unit is set to sigma.
                         for string values, allowed formats include:
                           'xsigma' or 'x' (= x-sigma level. e.g., '3sigma'), or
                           'topx' (= the x strongest ones, e.g. 'top5').
                         default is 3.0 (unit: sigma).
                 addwn -- additional wave number(s) of sinusoids to be used 
                         for fitting. 
                         (list) and (int) are accepted to specify every
                         wave numbers. also (str) can be used in case
                         you need to specify wave numbers in a certain range,
                         e.g., 'a-b' (= a, a+1, a+2, ..., b-1, b),
                               '<a'  (= 0,1,...,a-2,a-1),
                               '>=a' (= a, a+1, ... up to the maximum wave
                                      number corresponding to the Nyquist
                                      frequency for the case of FFT).
                         default: [0] (i.e., constant is subtracted at least)
                 rejwn -- wave number(s) of sinusoid NOT to be used for fitting.
                         can be set just as addwn but has higher priority:
                         wave numbers which are specified both in addwn
                         and rejwn will NOT be used. 
                         default: []
                 clipthresh -- clipping threshold for iterative fitting
                         default: 3
                 clipniter -- maximum iteration number
                         default: 0 (no iteration, i.e., no clipping)
        verify -- interactively verify the results of baseline fitting for each spectrum.
                  When verify = True, for each input spectrum the baseline
                  fit function and spectra before and after the fit are 
                  displayed in a plot window. At the prompt there are four
                  choices of action: 'Y' (accept the fit and continue to the
                  next input spectrum), 'N' (reject the fit and continue to the
                  next input spectrum), 'A' (accept the current fit and continue
                  non-interactively), and 'R' (reject the current fit and exit
                  from baseline fitting).
                  Note that when the baseline fit is rejected by 'N' or 'R',
                  no baseline fit is applied to the spectrum/spectra. 
                options: (bool) True,False
                default: False
                NOTE: Currently available only when blfunc='poly'
        verbose -- output fitting results to logger
                default: True
                example: If False, the fitting results including coefficients, 
                         residual rms, etc., are not output to the CASA logger, 
                         while the processing speed gets faster
        bloutput -- output fitting results to a text file
                default: True
                example: If False, the fitting results including coefficients, 
                         residual rms, etc., are not output to a text file 
                         (<outfile>_blparam.txt), while the processing 
                         speed gets faster
        blformat -- format of the logger output and text file specified with bloutput
                options: '', 'csv'
                default: '' (same as in the past, easy to read but huge)
        showprogress -- show progress status for large data
                default: True
        minnrow -- minimum number of input spectra to show progress status
                default: 1000
        outfile -- Name of output file
                default: '' (<infile>_bs)
        outform -- format of output file
                options: 'ASCII','SDFITS','MS','ASAP'
                default: 'ASAP'
                example: the ASAP format is easiest for further sd
                         processing; use MS for CASA imaging.
                         If ASCII, then will append some stuff to
                         the outfile name
        overwrite -- overwrite the output file if already exists
                options: (bool) True,False
                default: False
                WARNING: if outform='ASCII', this parameter is ignored
        plotlevel -- control for plotting of results
                options: (int) 0=none, 1=some, 2=more, <0=hardcopy
                default: 0 (no plotting)
                example: plotlevel<0 as abs(plotlevel), e.g.
                         -1 => hardcopy of final plot (will be named
                        <outfile>_bspec.eps)
                WARNING: be careful plotting in fsotf mode!



        DESCRIPTION:

        Task sdbaselineold performs baseline fitting/removal for single-dish spectra.
        The fit parameters, terms and rms of base-line are saved to an ascii 
        file, '<outfile>_blparam.txt'. 

        ASAP recognizes the data of the "AT" telescopes, but currently
        does not know about the GBT or any other telescope. This task
        does know about GBT. Telescope name is obtained from the data.
        If you wish to change the fluxunit (see below), and telescopeparm='',
        for the AT telescopes it will use internal telescope parameters for
        flux conversion. For GBT, it will use an approximate aperture
        efficiency conversion.  If you give telescopeparm a list , 
        then if the list has a single float it is assumed to
        be the gain in Jy/K, if two or more elements they are assumed
        to be telescope diameter (m) and aperture efficiency
        respectively.

        Note that sdbaselineold assumes that the fluxunit is set correctly in
        the data already.  If not, then set telescopeparm='FIX' and it
        will set the default units to fluxunit without conversion.
        NOTE: If the data in infile is an ms from GBT and the default flux
        unit is missing and this task automatically fixes the default fluxunit
        to 'K' before the conversion.

        WARNING for the GBT raw SDFITS format data as input:
        SDtasks are able to handle GBT raw SDFITS format data since the 
        data filler is available. However, the functionality is not well 
        tested yet, so that there may be unknown bugs.         

  
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'sdbaselineold'
        self.__globals__['taskname'] = 'sdbaselineold'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['infile'] = infile = self.parameters['infile']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['fluxunit'] = fluxunit = self.parameters['fluxunit']
            myparams['telescopeparm'] = telescopeparm = self.parameters['telescopeparm']
            myparams['specunit'] = specunit = self.parameters['specunit']
            myparams['restfreq'] = restfreq = self.parameters['restfreq']
            myparams['frame'] = frame = self.parameters['frame']
            myparams['doppler'] = doppler = self.parameters['doppler']
            myparams['scanlist'] = scanlist = self.parameters['scanlist']
            myparams['field'] = field = self.parameters['field']
            myparams['iflist'] = iflist = self.parameters['iflist']
            myparams['pollist'] = pollist = self.parameters['pollist']
            myparams['tau'] = tau = self.parameters['tau']
            myparams['masklist'] = masklist = self.parameters['masklist']
            myparams['maskmode'] = maskmode = self.parameters['maskmode']
            myparams['thresh'] = thresh = self.parameters['thresh']
            myparams['avg_limit'] = avg_limit = self.parameters['avg_limit']
            myparams['edge'] = edge = self.parameters['edge']
            myparams['blfunc'] = blfunc = self.parameters['blfunc']
            myparams['order'] = order = self.parameters['order']
            myparams['npiece'] = npiece = self.parameters['npiece']
            myparams['applyfft'] = applyfft = self.parameters['applyfft']
            myparams['fftmethod'] = fftmethod = self.parameters['fftmethod']
            myparams['fftthresh'] = fftthresh = self.parameters['fftthresh']
            myparams['addwn'] = addwn = self.parameters['addwn']
            myparams['rejwn'] = rejwn = self.parameters['rejwn']
            myparams['clipthresh'] = clipthresh = self.parameters['clipthresh']
            myparams['clipniter'] = clipniter = self.parameters['clipniter']
            myparams['verify'] = verify = self.parameters['verify']
            myparams['verbose'] = verbose = self.parameters['verbose']
            myparams['bloutput'] = bloutput = self.parameters['bloutput']
            myparams['blformat'] = blformat = self.parameters['blformat']
            myparams['showprogress'] = showprogress = self.parameters['showprogress']
            myparams['minnrow'] = minnrow = self.parameters['minnrow']
            myparams['outfile'] = outfile = self.parameters['outfile']
            myparams['outform'] = outform = self.parameters['outform']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']
            myparams['plotlevel'] = plotlevel = self.parameters['plotlevel']

        if type(scanlist)==int: scanlist=[scanlist]
        if type(iflist)==int: iflist=[iflist]
        if type(pollist)==int: pollist=[pollist]
        if type(edge)==int: edge=[edge]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['antenna'] = antenna
        mytmp['fluxunit'] = fluxunit
        mytmp['telescopeparm'] = telescopeparm
        mytmp['specunit'] = specunit
        mytmp['restfreq'] = restfreq
        mytmp['frame'] = frame
        mytmp['doppler'] = doppler
        mytmp['scanlist'] = scanlist
        mytmp['field'] = field
        mytmp['iflist'] = iflist
        mytmp['pollist'] = pollist
        mytmp['tau'] = tau
        mytmp['masklist'] = masklist
        mytmp['maskmode'] = maskmode
        mytmp['thresh'] = thresh
        mytmp['avg_limit'] = avg_limit
        mytmp['edge'] = edge
        mytmp['blfunc'] = blfunc
        mytmp['order'] = order
        mytmp['npiece'] = npiece
        mytmp['applyfft'] = applyfft
        mytmp['fftmethod'] = fftmethod
        mytmp['fftthresh'] = fftthresh
        mytmp['addwn'] = addwn
        mytmp['rejwn'] = rejwn
        mytmp['clipthresh'] = clipthresh
        mytmp['clipniter'] = clipniter
        mytmp['verify'] = verify
        mytmp['verbose'] = verbose
        mytmp['bloutput'] = bloutput
        mytmp['blformat'] = blformat
        mytmp['showprogress'] = showprogress
        mytmp['minnrow'] = minnrow
        mytmp['outfile'] = outfile
        mytmp['outform'] = outform
        mytmp['overwrite'] = overwrite
        mytmp['plotlevel'] = plotlevel
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'sdbaselineold.xml')

        casalog.origin('sdbaselineold')
	try :
          #if not trec.has_key('sdbaselineold') or not casac.casac.utils().verify(mytmp, trec['sdbaselineold']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['sdbaselineold'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('sdbaselineold', 'sdbaselineold.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'sdbaselineold'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = sdbaselineold(infile, antenna, fluxunit, telescopeparm, specunit, restfreq, frame, doppler, scanlist, field, iflist, pollist, tau, masklist, maskmode, thresh, avg_limit, edge, blfunc, order, npiece, applyfft, fftmethod, fftthresh, addwn, rejwn, clipthresh, clipniter, verify, verbose, bloutput, blformat, showprogress, minnrow, outfile, outform, overwrite, plotlevel)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'sdbaselineold'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('sdbaselineold', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['infile']  = ''
        a['antenna']  = 0
        a['fluxunit']  = ''
        a['specunit']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['tau']  = 0.0
        a['masklist']  = []
        a['maskmode']  = ''
        a['blfunc']  = 'poly'
        a['verify']  = False
        a['verbose']  = True
        a['bloutput']  = True
        a['blformat']  = ''
        a['showprogress']  = True
        a['outfile']  = ''
        a['outform']  = 'ASAP'
        a['overwrite']  = False
        a['plotlevel']  = 0

        a['fluxunit'] = {
                    0:{'value':''}, 
                    1:odict([{'value':'K'}, {'telescopeparm':''}]), 
                    2:odict([{'value':'k'}, {'telescopeparm':''}]), 
                    3:odict([{'value':'Jy'}, {'telescopeparm':''}]), 
                    4:odict([{'value':'jy'}, {'telescopeparm':''}])}
        a['specunit'] = {
                    0:{'value':''}, 
                    1:{'value':'channel'}, 
                    2:{'value':'GHz'}, 
                    3:{'value':'MHz'}, 
                    4:{'value':'kHz'}, 
                    5:{'value':'Hz'}, 
                    6:odict([{'value':'km/s'}, {'restfreq':''}])}
        a['maskmode'] = {
                    0:odict([{'value':'auto'}, {'thresh':5.0}, {'avg_limit':4}, {'edge':[0]}]), 
                    1:{'value':'list'}, 
                    2:{'value':'interact'}}
        a['blfunc'] = {
                    0:odict([{'value':'poly'}, {'order':5}, {'clipthresh':3.0}, {'clipniter':0}]), 
                    1:odict([{'value':'chebyshev'}, {'order':5}, {'clipthresh':3.0}, {'clipniter':0}]), 
                    2:odict([{'value':'cspline'}, {'npiece':2}, {'clipthresh':3.0}, {'clipniter':0}]), 
                    3:odict([{'value':'sinusoid'}, {'applyfft':True}, {'fftmethod':'fft'}, {'fftthresh':3.0}, {'addwn':[0]}, {'rejwn':[]}, {'clipthresh':3.0}, {'clipniter':0}])}
        a['showprogress'] = {
                    0:odict([{'value':True}, {'minnrow':1000}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='sdbaselineold', subkey=None):
        desc={'sdbaselineold': 'ASAP SD task: fit/subtract a spectral baseline ',
               'infile': 'name of input SD dataset',
               'antenna': 'antenna name or id (only effective for MS input)',
               'fluxunit': 'units for line flux (K,Jy) (''=current)',
               'telescopeparm': 'param of telescope for flux conversion',
               'specunit': 'units for spectral axis (channel,km/s,GHz)',
               'restfreq': 'rest frequency (default unit: Hz)',
               'frame': 'frequency reference frame, e.g. LSRK (''=current)',
               'doppler': 'doppler convention, e.g. RADIO (''=current)',
               'scanlist': 'list of scans to use (e.g. [1,2,3,4])',
               'field': 'string for selection by source name',
               'iflist': 'list of IF ids to select (e.g. [0,1])',
               'pollist': 'list of polarization ids to select (e.g. [0,1])',
               'tau': 'atmospheric optical depth for correction',
               'masklist': 'list or string of mask regions to INCLUDE in BASELINE fit',
               'maskmode': 'mode of setting additional channel masks',
               'thresh': 'S/N threshold for linefinder',
               'avg_limit': 'channel averaging for broad lines',
               'edge': 'channels to drop at beginning and end of spectrum',
               'blfunc': 'baseline model function',
               'order': 'order of baseline polynomial',
               'npiece': 'number of element polynomials of spline',
               'applyfft': 'automatically set wave numbers of sinusoids',
               'fftmethod': 'method for automatically set wave numbers of sinusoids',
               'fftthresh': 'threshold to select wave numbers of sinusoids',
               'addwn': 'additional wave numbers to use',
               'rejwn': 'wave numbers NOT to use',
               'clipthresh': 'clipping threshold for iterative fitting',
               'clipniter': 'maximum iteration number',
               'verify': 'interactively verify the results of baseline fitting for each spectrum. (only for blfunc="poly")',
               'verbose': 'output fitting results to logger',
               'bloutput': 'output fitting results to a text file',
               'blformat': 'format of the text file specified with bloutput',
               'showprogress': 'show progress status for large data',
               'minnrow': 'minimum number of input spectra to show progress status',
               'outfile': 'output file name',
               'outform': 'output file format (ASCII,MS,SDFITS,ASAP)',
               'overwrite': 'overwrite the output file if already exists',
               'plotlevel': 'plot results (0=none,1+=some,<0=hardcopy)',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['infile']  = ''
        a['antenna']  = 0
        a['fluxunit']  = ''
        a['telescopeparm']  = ''
        a['specunit']  = ''
        a['restfreq']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['tau']  = 0.0
        a['masklist']  = []
        a['maskmode']  = ''
        a['thresh']  = 5.0
        a['avg_limit']  = 4
        a['edge']  = [0]
        a['blfunc']  = 'poly'
        a['order']  = 5
        a['npiece']  = 2
        a['applyfft']  = True
        a['fftmethod']  = 'fft'
        a['fftthresh']  = 3.0
        a['addwn']  = [0]
        a['rejwn']  = []
        a['clipthresh']  = 3.0
        a['clipniter']  = 0
        a['verify']  = False
        a['verbose']  = True
        a['bloutput']  = True
        a['blformat']  = ''
        a['showprogress']  = True
        a['minnrow']  = 1000
        a['outfile']  = ''
        a['outform']  = 'ASAP'
        a['overwrite']  = False
        a['plotlevel']  = 0

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['fluxunit']  == 'K':
            a['telescopeparm'] = ''

        if self.parameters['fluxunit']  == 'k':
            a['telescopeparm'] = ''

        if self.parameters['fluxunit']  == 'Jy':
            a['telescopeparm'] = ''

        if self.parameters['fluxunit']  == 'jy':
            a['telescopeparm'] = ''

        if self.parameters['specunit']  == 'km/s':
            a['restfreq'] = ''

        if self.parameters['maskmode']  == 'auto':
            a['thresh'] = 5.0
            a['avg_limit'] = 4
            a['edge'] = [0]

        if self.parameters['blfunc']  == 'poly':
            a['order'] = 5
            a['clipthresh'] = 3.0
            a['clipniter'] = 0

        if self.parameters['blfunc']  == 'chebyshev':
            a['order'] = 5
            a['clipthresh'] = 3.0
            a['clipniter'] = 0

        if self.parameters['blfunc']  == 'cspline':
            a['npiece'] = 2
            a['clipthresh'] = 3.0
            a['clipniter'] = 0

        if self.parameters['blfunc']  == 'sinusoid':
            a['applyfft'] = True
            a['fftmethod'] = 'fft'
            a['fftthresh'] = 3.0
            a['addwn'] = [0]
            a['rejwn'] = []
            a['clipthresh'] = 3.0
            a['clipniter'] = 0

        if self.parameters['showprogress']  == True:
            a['minnrow'] = 1000

        if a.has_key(paramname) :
	      return a[paramname]
sdbaselineold_cli = sdbaselineold_cli_()
