#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from types import * 
from task_sdfitold import sdfitold
class sdfitold_cli_:
    __name__ = "sdfitold"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (sdfitold_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'infile':None, 'antenna':None, 'fluxunit':None, 'telescopeparm':None, 'specunit':None, 'restfreq':None, 'frame':None, 'doppler':None, 'scanlist':None, 'field':None, 'iflist':None, 'pollist':None, 'fitfunc':None, 'fitmode':None, 'maskline':None, 'invertmask':None, 'nfit':None, 'thresh':None, 'min_nchan':None, 'avg_limit':None, 'box_size':None, 'edge':None, 'outfile':None, 'overwrite':None, 'plotlevel':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, infile=None, antenna=None, fluxunit=None, telescopeparm=None, specunit=None, restfreq=None, frame=None, doppler=None, scanlist=None, field=None, iflist=None, pollist=None, fitfunc=None, fitmode=None, maskline=None, invertmask=None, nfit=None, thresh=None, min_nchan=None, avg_limit=None, box_size=None, edge=None, outfile=None, overwrite=None, plotlevel=None, ):

        """ASAP SD task: fit a spectral line

	Detailed Description: 

    ASAP SD line-fitting task:

    Modified 2008-01-29 TT
    Task Version 2007-03-04 STM
  
	Arguments :
		infile:	name of input SD dataset
		   Default Value: 

		antenna:	antenna name or id (only effective for MS input)
		   Default Value: 0

		fluxunit:	units for line flux (K,Jy) (''=current)
		   Default Value: 

		telescopeparm:	param of telescope for flux conversion
		   Default Value: 

		specunit:	units for spectral axis (channel,km/s,GHz)
		   Default Value: 
		   Allowed Values:
				
				channel
				km/s
				GHz
				MHz
				kHz
				Hz

		restfreq:	rest frequency (default unit: Hz)
		   Default Value: 

		frame:	frequency reference frame, e.g. LSRK (''=current)
		   Default Value: 

		doppler:	doppler convention, e.g. RADIO (''=current)
		   Default Value: 

		scanlist:	list of scans to use (e.g. [1,2,3,4])
		   Default Value: 

		field:	string for selection by source name
		   Default Value: 

		iflist:	list of IF ids to select (e.g. [0,1])
		   Default Value: 

		pollist:	list of polarization ids to select (e.g. [1])
		   Default Value: 

		fitfunc:	function for fitting
		   Default Value: gauss
		   Allowed Values:
				gauss
				lorentz

		fitmode:	mode for fitting
		   Default Value: auto

		maskline:	list of mask regions to INCLUDE in LINE fitting
		   Default Value: 

		invertmask:	invert mask (EXCLUDE masklist instead)
		   Default Value: False

		nfit:	list of number of gaussian/lorentzian lines to fit in in maskline region (ignored when fitmode="auto")
		   Default Value: 

		thresh:	S/N threshold for linefinder
		   Default Value: 5.0

		min_nchan:	minimum number of consecutive channels for linefinder
		   Default Value: 3

		avg_limit:	channel averaging for broad lines
		   Default Value: 4

		box_size:	running mean box size
		   Default Value: 0.2

		edge:	channels to drop at beginning and end of spectrum
		   Default Value: 0

		outfile:	name of output file for fit results
		   Default Value: 

		overwrite:	overwrite the outfile if already exists
		   Default Value: False

		plotlevel:	control for plotting of results
		   Default Value: 0

	Returns: void

	Example :

        Keyword arguments:
        infile -- name of input SD dataset
                default: none - must input file name
                example: 'mysd.asap'
                         See sdcalold for allowed formats.
        antenna -- antenna name or id (only effective for MS input). 
        fluxunit -- units for line flux
                options: (str) 'K','Jy',''
                default: '' (keep current fluxunit)
                WARNING: For GBT data, see description below.
            >>> fluxunit expandable parameter
                 telescopeparm -- the telescope characteristics
                        options: (str) name or (list) list of gain info
                        default: '' (none set)
                        example: if telescopeparm='', it tries to get the telescope
                                 name from the data.
                                 Full antenna parameters (diameter,ap.eff.) known
                                 to ASAP are
                                 'ATPKSMB', 'ATPKSHOH', 'ATMOPRA', 'DSS-43',
                                 'CEDUNA','HOBART'. For GBT, it fixes default fluxunit
                                 to 'K' first then convert to a new fluxunit.
                                 telescopeparm=[104.9,0.43] diameter(m), ap.eff.
                                 telescopeparm=[0.743] gain in Jy/K
                                 telescopeparm='FIX' to change default fluxunit
                                 see description below

        specunit -- units for spectral axis
                options: (str) 'channel','km/s','GHz','MHz','kHz','Hz',''
                default: '' (=current)
                example: this will be the units for maskline
            >>> specunit expandable parameters
                 restfreq -- rest frequency
                         available type includes float, int, string, list of float, 
                         list of int, list of string, and list of dictionary. the 
                         default unit of restfreq in case of float, int, or string 
                         without unit is Hz. string input can be a value only 
                         (treated as Hz) or a value followed by unit for which 'GHz',
                         'MHz','kHz',and 'Hz' are available. 
                         a list can be used to set different rest frequencies for 
                         each IF. the length of list input must be nIF. dictionary 
                         input should be a pair of molecule name and frequency with 
                         keys of 'name' and 'value', respectively. values in the 
                         dictionary input follows the same manner as for single 
                         float or string input. 
                         example: 345.796
                                  '1420MHz'
                                  [345.8, 347.0, 356.7]
                                  ['345.8MHz', '347.0MHz', '356.7MHz']
                                  [{'name':'CO','value':345}]
        frame -- frequency frame for spectral axis
                options: (str) 'LSRK','REST','TOPO','LSRD','BARY',
                         'GEO','GALACTO','LGROUP','CMB'
                default: currently set frame in scantable
                WARNING: frame='REST' not yet implemented
        doppler -- doppler mode
                options: (str) 'RADIO','OPTICAL','Z','BETA','GAMMA'
                default: currently set doppler in scantable
        scanlist -- list of scan numbers to process
                default: [] (use all scans)
                example: [21,22,23,24]
        field -- selection string for selecting scans by name
                default: '' (no name selection)
                example: 'FLS3a*'
                this selection is in addition to scanlist and iflist
        iflist -- list of IF id numbers to select
                default: [] (use all IFs)
                example: [15]
        pollist -- list of polarization id numbers to select
                default: [] (use all polarizations)
                example: [1]
        fitfunc -- function for fitting
                options: (str) 'gauss','lorentz'
                default: 'gauss'
        fitmode -- mode for fitting
                options: (str) 'list','auto','interact'
                default: 'auto'
                example: 'list' will use maskline to define regions to
                                fit for lines with nfit in each
                         'auto' will use the linefinder to fit for lines
                                using the following parameters
                         'interact' allows adding and deleting mask 
                                regions by drawing rectangles on the plot 
                                with mouse. Draw a rectangle with LEFT-mouse 
                                to ADD the region to the mask and with RIGHT-mouse 
                                to DELETE the region. 

            >>> fitmode expandable parameters             
                 thresh -- S/N threshold for linefinder
                         default: 5
                         example: a single channel S/N ratio above which the channel is
                                  considered to be a detection
        	 min_nchan -- minimum number of consecutive channels for linefinder
               	         default: 3
                         example: minimum number of consecutive channels required to pass threshold
                 avg_limit -- channel averaging for broad lines
                         default: 4
                         example: a number of consecutive channels not greater than
                                  this parameter can be averaged to search for broad lines
                 box_size -- running mean box size
                         default: 0.2
                         example: a running mean box size specified as a fraction
                                  of the total spectrum length
                 edge -- channels to drop at beginning and end of spectrum
                         default: 0
                         example: [1000] drops 1000 channels at beginning AND end
                                  [1000,500] drops 1000 from beginning and 500 from end

                 Note: For bad baselines threshold should be increased,
                 and avg_limit decreased (or even switched off completely by
                 setting this parameter to 1) to avoid detecting baseline
                 undulations instead of real lines.

        maskline -- list of mask regions to INCLUDE in LINE fitting
                default: all
                example: maskline=[[3900,4300]] for a single region, or
                         maskline=[[3900,4300],[5000,5400]] for two, etc.
        invertmask -- invert mask (EXCLUDE masklist instead)
                options: (bool) True, False
                default: False
                example: invertmask=True, then will make one region that is
                         the exclusion of the maskline regions
        nfit -- list of number of gaussian/lorentzian lines to fit in in maskline region (ignored when fitmode='auto')
                default: 0 (no fitting)
                example: nfit=[1] for single line in single region,
                         nfit=[2] for two lines in single region,
                         nfit=[1,1] for single lines in each of two regions, etc.
        outfile -- name of output file for fit results
                default: no output fit file
                example: 'mysd.fit'
        overwrite -- overwrite the outfile if already exists
                options: (bool) True, False
                default: False
        plotlevel -- control for plotting of results
                options: (int) 0=none, 1=some, 2=more
                default: 0 (no plotting)
                example: plotlevel=1 plots fit
                         plotlevel=2 plots fit and residual 
                         no hardcopy available for fitter
                WARNING: be careful plotting OTF data with lots of fields

        -------------------------------------------------------------------
        Returns a Python dictionary of line statistics
                keys:    'peak','cent','fwhm','nfit'
                example: each value is a list of lists with one list of
                         2 entries [fitvalue,error] per component.
                         e.g. xstat['peak']=[[234.9, 4.8],[234.2, 5.3]]
                         for 2 components.


        DESCRIPTION:

        Task sdfitold is a basic line-fitter for single-dish spectra.
        It assumes that the spectra have been calibrated in sdcalold
        or sdreduceold.

        Furthermore, it assumes that any selection of scans, IFs,
        polarizations, and time and channel averaging/smoothing has
        also already been done (in other sd tasks) as there are no controls
        for these.  Note that you can use sdsaveold to do selection, writing
        out a new scantable.

        Note that multiple scans, IFs, and polarizations can in principle 
        be handled, but we recommend that you use scanlist, field, iflist, 
        and pollist to give a single selection for each fit.

        Currently, you can choose Gaussian or Lorentzian profile as a 
        fitting model. 

        For complicated spectra, sdfitold does not do a good job of
        "auto-guessing" the starting model for the fit.  We recommend
        you use sd.fitter in the toolkit which has more options, such
        as fixing components in the fit and supplying starting guesses
        by hand.

        WARNING: sdfitold will currently return the fit for the first
        row in the scantable.

        ASAP recognizes the data of the "AT" telescopes, but currently
        does not know about the GBT or any other telescope. This task
        does know about GBT. Telescope name is obtained from the data.
        If you wish to change the fluxunit (see below), and telescopeparm='',
        for the AT telescopes it will use internal telescope parameters for
        flux conversion. For GBT, it will use an approximate aperture
        efficiency conversion.  If you give telescopeparm a list, then 
        if the list has a single float it is assumed to be the gain in Jy/K, 
        if two or more elements they are assumed to be telescope diameter (m) 
        and aperture efficiency respectively.

        WARNING for the GBT raw SDFITS format data as input:
        SDtasks are able to handle GBT raw SDFITS format data since the 
        data filler is available. However, the functionality is not well 
        tested yet, so that there may be unknown bugs.  

  
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'sdfitold'
        self.__globals__['taskname'] = 'sdfitold'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['infile'] = infile = self.parameters['infile']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['fluxunit'] = fluxunit = self.parameters['fluxunit']
            myparams['telescopeparm'] = telescopeparm = self.parameters['telescopeparm']
            myparams['specunit'] = specunit = self.parameters['specunit']
            myparams['restfreq'] = restfreq = self.parameters['restfreq']
            myparams['frame'] = frame = self.parameters['frame']
            myparams['doppler'] = doppler = self.parameters['doppler']
            myparams['scanlist'] = scanlist = self.parameters['scanlist']
            myparams['field'] = field = self.parameters['field']
            myparams['iflist'] = iflist = self.parameters['iflist']
            myparams['pollist'] = pollist = self.parameters['pollist']
            myparams['fitfunc'] = fitfunc = self.parameters['fitfunc']
            myparams['fitmode'] = fitmode = self.parameters['fitmode']
            myparams['maskline'] = maskline = self.parameters['maskline']
            myparams['invertmask'] = invertmask = self.parameters['invertmask']
            myparams['nfit'] = nfit = self.parameters['nfit']
            myparams['thresh'] = thresh = self.parameters['thresh']
            myparams['min_nchan'] = min_nchan = self.parameters['min_nchan']
            myparams['avg_limit'] = avg_limit = self.parameters['avg_limit']
            myparams['box_size'] = box_size = self.parameters['box_size']
            myparams['edge'] = edge = self.parameters['edge']
            myparams['outfile'] = outfile = self.parameters['outfile']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']
            myparams['plotlevel'] = plotlevel = self.parameters['plotlevel']

        if type(scanlist)==int: scanlist=[scanlist]
        if type(iflist)==int: iflist=[iflist]
        if type(pollist)==int: pollist=[pollist]
        if type(nfit)==int: nfit=[nfit]
        if type(edge)==int: edge=[edge]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['antenna'] = antenna
        mytmp['fluxunit'] = fluxunit
        mytmp['telescopeparm'] = telescopeparm
        mytmp['specunit'] = specunit
        mytmp['restfreq'] = restfreq
        mytmp['frame'] = frame
        mytmp['doppler'] = doppler
        mytmp['scanlist'] = scanlist
        mytmp['field'] = field
        mytmp['iflist'] = iflist
        mytmp['pollist'] = pollist
        mytmp['fitfunc'] = fitfunc
        mytmp['fitmode'] = fitmode
        mytmp['maskline'] = maskline
        mytmp['invertmask'] = invertmask
        mytmp['nfit'] = nfit
        mytmp['thresh'] = thresh
        mytmp['min_nchan'] = min_nchan
        mytmp['avg_limit'] = avg_limit
        mytmp['box_size'] = box_size
        mytmp['edge'] = edge
        mytmp['outfile'] = outfile
        mytmp['overwrite'] = overwrite
        mytmp['plotlevel'] = plotlevel
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'sdfitold.xml')

        casalog.origin('sdfitold')
	try :
          #if not trec.has_key('sdfitold') or not casac.casac.utils().verify(mytmp, trec['sdfitold']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['sdfitold'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('sdfitold', 'sdfitold.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'sdfitold'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = sdfitold(infile, antenna, fluxunit, telescopeparm, specunit, restfreq, frame, doppler, scanlist, field, iflist, pollist, fitfunc, fitmode, maskline, invertmask, nfit, thresh, min_nchan, avg_limit, box_size, edge, outfile, overwrite, plotlevel)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'sdfitold'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('sdfitold', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['infile']  = ''
        a['antenna']  = 0
        a['fluxunit']  = ''
        a['specunit']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['fitfunc']  = 'gauss'
        a['fitmode']  = 'auto'
        a['maskline']  = []
        a['invertmask']  = False
        a['nfit']  = []
        a['outfile']  = ''
        a['overwrite']  = False
        a['plotlevel']  = 0

        a['fluxunit'] = {
                    0:{'value':''}, 
                    1:odict([{'value':'K'}, {'telescopeparm':''}]), 
                    2:odict([{'value':'k'}, {'telescopeparm':''}]), 
                    3:odict([{'value':'Jy'}, {'telescopeparm':''}]), 
                    4:odict([{'value':'jy'}, {'telescopeparm':''}])}
        a['specunit'] = {
                    0:{'value':''}, 
                    1:{'value':'channel'}, 
                    2:{'value':'GHz'}, 
                    3:{'value':'MHz'}, 
                    4:{'value':'kHz'}, 
                    5:{'value':'Hz'}, 
                    6:odict([{'value':'km/s'}, {'restfreq':''}])}
        a['fitmode'] = {
                    0:odict([{'value':'auto'}, {'thresh':5.0}, {'min_nchan':3}, {'avg_limit':4}, {'box_size':0.2}, {'edge':[0]}]), 
                    1:{'value':'list'}, 
                    2:{'value':'interact'}}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='sdfitold', subkey=None):
        desc={'sdfitold': 'ASAP SD task: fit a spectral line',
               'infile': 'name of input SD dataset',
               'antenna': 'antenna name or id (only effective for MS input)',
               'fluxunit': 'units for line flux (K,Jy) (''=current)',
               'telescopeparm': 'param of telescope for flux conversion',
               'specunit': 'units for spectral axis (channel,km/s,GHz)',
               'restfreq': 'rest frequency (default unit: Hz)',
               'frame': 'frequency reference frame, e.g. LSRK (''=current)',
               'doppler': 'doppler convention, e.g. RADIO (''=current)',
               'scanlist': 'list of scans to use (e.g. [1,2,3,4])',
               'field': 'string for selection by source name',
               'iflist': 'list of IF ids to select (e.g. [0,1])',
               'pollist': 'list of polarization ids to select (e.g. [1])',
               'fitfunc': 'function for fitting',
               'fitmode': 'mode for fitting',
               'maskline': 'list of mask regions to INCLUDE in LINE fitting',
               'invertmask': 'invert mask (EXCLUDE masklist instead)',
               'nfit': 'list of number of gaussian/lorentzian lines to fit in in maskline region (ignored when fitmode="auto")',
               'thresh': 'S/N threshold for linefinder',
               'min_nchan': 'minimum number of consecutive channels for linefinder',
               'avg_limit': 'channel averaging for broad lines',
               'box_size': 'running mean box size',
               'edge': 'channels to drop at beginning and end of spectrum',
               'outfile': 'name of output file for fit results',
               'overwrite': 'overwrite the outfile if already exists',
               'plotlevel': 'control for plotting of results',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['infile']  = ''
        a['antenna']  = 0
        a['fluxunit']  = ''
        a['telescopeparm']  = ''
        a['specunit']  = ''
        a['restfreq']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['fitfunc']  = 'gauss'
        a['fitmode']  = 'auto'
        a['maskline']  = []
        a['invertmask']  = False
        a['nfit']  = []
        a['thresh']  = 5.0
        a['min_nchan']  = 3
        a['avg_limit']  = 4
        a['box_size']  = 0.2
        a['edge']  = [0]
        a['outfile']  = ''
        a['overwrite']  = False
        a['plotlevel']  = 0

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['fluxunit']  == 'K':
            a['telescopeparm'] = ''

        if self.parameters['fluxunit']  == 'k':
            a['telescopeparm'] = ''

        if self.parameters['fluxunit']  == 'Jy':
            a['telescopeparm'] = ''

        if self.parameters['fluxunit']  == 'jy':
            a['telescopeparm'] = ''

        if self.parameters['specunit']  == 'km/s':
            a['restfreq'] = ''

        if self.parameters['fitmode']  == 'auto':
            a['thresh'] = 5.0
            a['min_nchan'] = 3
            a['avg_limit'] = 4
            a['box_size'] = 0.2
            a['edge'] = [0]

        if a.has_key(paramname) :
	      return a[paramname]
sdfitold_cli = sdfitold_cli_()
