#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from types import * 
from task_sdflagold import sdflagold
class sdflagold_cli_:
    __name__ = "sdflagold"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (sdflagold_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'infile':None, 'antenna':None, 'specunit':None, 'restfreq':None, 'frame':None, 'doppler':None, 'scanlist':None, 'field':None, 'iflist':None, 'pollist':None, 'maskflag':None, 'flagrow':None, 'clip':None, 'clipminmax':None, 'clipoutside':None, 'flagmode':None, 'interactive':None, 'showflagged':None, 'outfile':None, 'outform':None, 'overwrite':None, 'plotlevel':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, infile=None, antenna=None, specunit=None, restfreq=None, frame=None, doppler=None, scanlist=None, field=None, iflist=None, pollist=None, maskflag=None, flagrow=None, clip=None, clipminmax=None, clipoutside=None, flagmode=None, interactive=None, showflagged=None, outfile=None, outform=None, overwrite=None, plotlevel=None, ):

        """ASAP SD spectral flagging task 

	Detailed Description: 

ASAP SD spectral/row flagging task (based on the ALMATST5 recommendations)

### WARNING ###
This task filters records that appears in output data if any of the 
following selection parameters are set, which are, scanlist, iflist, 
pollist, and field. Records in the input dataset are removed from output 
dataset unless they match all of the selection set.
You may want to use a new task, sdflag2old, if you want to keep all
records in input dataset and use selection parameters just for selecting
data to modify flag information.



	Arguments :
		infile:	name of input SD dataset
		   Default Value: 

		antenna:	antenna name or id (only effective for MS input)
		   Default Value: 0

		specunit:	units for spectral axis (channel,km/s,GHz)
		   Default Value: 
		   Allowed Values:
				
				channel
				km/s
				GHz
				MHz
				kHz
				Hz

		restfreq:	rest frequency (default unit: Hz)
		   Default Value: 

		frame:	frequency reference frame, e.g. LSRK (''=current)
		   Default Value: 

		doppler:	doppler convention, e.g. RADIO (''=current)
		   Default Value: 

		scanlist:	list of scans to use and output (e.g. [1,2,3,4])
		   Default Value: 

		field:	string for selection by source name for flagging and output
		   Default Value: 

		iflist:	list of IF ids to use and output (e.g. [0,1])
		   Default Value: 

		pollist:	list of polarization by ids or names to use and output (e.g. [0,1])
		   Default Value: 

		maskflag:	list of mask regions to flag/unflag
		   Default Value: 

		flagrow:	list of row numbers to apply row-based flagging/unflagging
		   Default Value: 

		clip:	flag data outside a specified range
		   Default Value: False

		clipminmax:	range of data that will NOT be flagged
		   Default Value: 

		clipoutside:	clip outside the range, or within it
		   Default Value: True

		flagmode:	flag mode (flag,unflag)
		   Default Value: flag

		interactive:	determines interactive flagging
		   Default Value: False

		showflagged:	show flagged data on plots
		   Default Value: False

		outfile:	name of output file (See a WARNING in help document)
		   Default Value: 

		outform:	output file format (ASCII,MS,SDFITS,ASAP) (See a WARNING in help document)
		   Default Value: ASAP
		   Allowed Values:
				ASCII
				ascii
				MS
				ms
				MS2
				ms2
				SDFITS
				sdfits
				ASAP
				asap

		overwrite:	overwrite the output file if already exists (See a WARNING in help document)
		   Default Value: True

		plotlevel:	control for plotting of results
		   Default Value: 0

	Returns: void

	Example :

        Keyword arguments:
        infile -- name of input SD dataset
        antenna -- antenna name or id (only effective for MS input). 
        specunit -- units for spectral axis
                options: (str) 'channel','km/s','GHz','MHz','kHz','Hz',''
                default: '' (=current)
                example: this will be the units for maskflag
            >>> specunit expandable parameters
                 restfreq -- rest frequency
                         available type includes float, int, string, list of float, 
                         list of int, list of string, and list of dictionary. the 
                         default unit of restfreq in case of float, int, or string 
                         without unit is Hz. string input can be a value only 
                         (treated as Hz) or a value followed by unit for which 'GHz',
                         'MHz','kHz',and 'Hz' are available. 
                         a list can be used to set different rest frequencies for 
                         each IF. the length of list input must be nIF. dictionary 
                         input should be a pair of molecule name and frequency with 
                         keys of 'name' and 'value', respectively. values in the 
                         dictionary input follows the same manner as for single 
                         float or string input. 
                         example: 345.796
                                  '1420MHz'
                                  [345.8, 347.0, 356.7]
                                  ['345.8MHz', '347.0MHz', '356.7MHz']
                                  [{'name':'CO','value':345}]
        frame -- frequency frame for spectral axis
                options: (str) 'LSRK','REST','TOPO','LSRD','BARY',
                         'GEO','GALACTO','LGROUP','CMB'
                default: currently set frame in scantable
                WARNING: frame='REST' not yet implemented
        doppler -- doppler mode
                options: (str) 'RADIO','OPTICAL','Z','BETA','GAMMA'
                default: currently set doppler in scantable
        scanlist -- list of scan numbers to be considered for flagging and output
                default: [] (use all scans)
                example: [21,22,23,24]
                this selection is in addition to field and iflist
        field -- field name for selecting scans to be considered for flagging and output
                default: '' (no name selection)
                example: 'FLS3a*'
                this selection is in addition to scanlist, iflist, and pollist
        iflist -- list of IF id numbers to be considered for flagging and output
                default: [] (use all IFs)
                example: [15]
                this selection is in addition to scanlist, field, and pollist
        pollist -- list of polarization id numbers to be considered for flagging and output
                default: [] (use all polarizations)
                example: [1]
                this selection is in addition to scanlist, field, and iflist
        maskflag -- list of mask regions to apply flag/unflag 
                    Note, this parameter is ignored if one or more rows are 
                    given in flagrow, or clip=True.
                default: [] (entire spectrum)
                example: [[1000,3000],[5000,7000]]
        flagrow -- list of row numbers to apply flag/unflag
                   Note, this parameter is effective only when one or more row 
                   numbers are given explicitly and also clip=False
                default: [] (no row selection)
                example: [0, 2, 3]
        clip -- flag data that are outside a specified range
                options: (bool)True,False
                default: False
             >>> clip expandable parameters
                clipminmax -- range of data that will NOT be flagged
                        default: [] means do not use clip option
                        example: [0.0,1.5]
                clipoutside -- clip OUTSIDE the range ?
                        options: (bool)True,False
                        default: True
                        example: clipoutside=False means flag data WITHIN the range.
        flagmode -- flag mode
                default: 'flag'
                options: 'flag','unflag'
        interactive -- determines interactive flagging
                options: (bool) True,False
                default: False
             >>> interactive expandable parameters
                showflagged -- show flagged data on plots
                        default: False
        outfile -- Name of output file
                default: ''
                Note: by default (outfile=''), actual output file name is set as follows: 
                      (1) if overwrite=True (default), infile (input) will be overwritten.
                      WARNING: If the formats of input and ouput files are different, 
                               this causes complete loss of input file.
                      (2) if overwrite=False, outfile will be <infile>_f. 
        outform -- format of output file
                options: 'ASCII','SDFITS','MS','ASAP'
                default: 'ASAP'
                example: the ASAP format is easiest for further sd
                         processing; use MS for CASA imaging.
                WARNING: Be sure outform is same as the input file format when you 
                         overwrite the input file by overwrite=True and outfile='' (default).
        overwrite -- overwrite the output file if already exists
                options: (bool) True,False
                default: True
                WARNING: input file is overwritten if overwrite=True and outfile='' (default). 
                         This causes the complete loss of input file if the formats of
                         input and ouput files are different.
        plotlevel -- control for plotting of results
                options: (int) 0=none, 1=some, 2=more, <0=hardcopy
                default: 0 (no plotting)
                example: plotlevel<0 as abs(plotlevel), e.g.
                         -1 => hardcopy of final plot (will be named
                         <outfile>_flag.eps)
                WARNING: be careful plotting in fsotf mode!

        -------------------------------------------------------------------

        DESCRIPTION:

        Task sdflagold performs both interactive and non-interactive channel/row 
        based flagging on spectra.
        Currently, the available ways of non-interactive flagging include: 
        (1) channel based flagging by specifying a range of spectral values 
        with clip=True, (2) row based flagging by specifying a list of row 
        numbers to the flagrow parameter, and (3) channel based flagging by 
        specifying regions in channel to the maskflag parameter. 
        These three ways of flagging can not be executed simultaneously. 
        If more than one parameter above are specified, the task looks for 
        them in the above order and operates the first specified way of 
        flagging operation.

        Interactive flagging is available when interactive=True. 
        The available ways of interactive flagging include: 
        (1) row based flagging by selecting 'panel' and (2) channel
        based flagging by selecting 'region's of channels on Flag plotter. 
        Note that the Flag plotter is loaded after carrying out the 
        non-interactive flag operation if any specified. See the cookbook for
        details of how to select channel regions and spectra on the plotter.

        If plotlevel>=1, the task asks you if you really apply the 
        flags before it is actually written to the data with a plot 
        indicating flagged regions.
        Please note that this task is still experimental.

        WARNING for overwrite option:
        Be sure 'outform' is the same as data format of input file when you
        overwrite it. Since CASA 3.1, the default value of the option 'overwrite'
        has been changed to True, thereby the current dataset (infile) is 
        overwritten unless a different file name is set to outfile. 
        There is a known issue in overwriting infile. If 'outform' differs to the
        data format of infile, the data is overwritten with the new data format 
        (specified by 'outform') and the data in the original format will be lost.

        WARNING for the GBT raw SDFITS format data as input:
        SDtasks are able to handle GBT raw SDFITS format data since the 
        data filler is available. However, the functionality is not well 
        tested yet, so that there may be unknown bugs.  
 
  
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'sdflagold'
        self.__globals__['taskname'] = 'sdflagold'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['infile'] = infile = self.parameters['infile']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['specunit'] = specunit = self.parameters['specunit']
            myparams['restfreq'] = restfreq = self.parameters['restfreq']
            myparams['frame'] = frame = self.parameters['frame']
            myparams['doppler'] = doppler = self.parameters['doppler']
            myparams['scanlist'] = scanlist = self.parameters['scanlist']
            myparams['field'] = field = self.parameters['field']
            myparams['iflist'] = iflist = self.parameters['iflist']
            myparams['pollist'] = pollist = self.parameters['pollist']
            myparams['maskflag'] = maskflag = self.parameters['maskflag']
            myparams['flagrow'] = flagrow = self.parameters['flagrow']
            myparams['clip'] = clip = self.parameters['clip']
            myparams['clipminmax'] = clipminmax = self.parameters['clipminmax']
            myparams['clipoutside'] = clipoutside = self.parameters['clipoutside']
            myparams['flagmode'] = flagmode = self.parameters['flagmode']
            myparams['interactive'] = interactive = self.parameters['interactive']
            myparams['showflagged'] = showflagged = self.parameters['showflagged']
            myparams['outfile'] = outfile = self.parameters['outfile']
            myparams['outform'] = outform = self.parameters['outform']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']
            myparams['plotlevel'] = plotlevel = self.parameters['plotlevel']

        if type(scanlist)==int: scanlist=[scanlist]
        if type(iflist)==int: iflist=[iflist]
        if type(maskflag)==int: maskflag=[maskflag]
        if type(flagrow)==int: flagrow=[flagrow]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['antenna'] = antenna
        mytmp['specunit'] = specunit
        mytmp['restfreq'] = restfreq
        mytmp['frame'] = frame
        mytmp['doppler'] = doppler
        mytmp['scanlist'] = scanlist
        mytmp['field'] = field
        mytmp['iflist'] = iflist
        mytmp['pollist'] = pollist
        mytmp['maskflag'] = maskflag
        mytmp['flagrow'] = flagrow
        mytmp['clip'] = clip
        mytmp['clipminmax'] = clipminmax
        mytmp['clipoutside'] = clipoutside
        mytmp['flagmode'] = flagmode
        mytmp['interactive'] = interactive
        mytmp['showflagged'] = showflagged
        mytmp['outfile'] = outfile
        mytmp['outform'] = outform
        mytmp['overwrite'] = overwrite
        mytmp['plotlevel'] = plotlevel
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'sdflagold.xml')

        casalog.origin('sdflagold')
	try :
          #if not trec.has_key('sdflagold') or not casac.casac.utils().verify(mytmp, trec['sdflagold']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['sdflagold'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('sdflagold', 'sdflagold.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'sdflagold'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = sdflagold(infile, antenna, specunit, restfreq, frame, doppler, scanlist, field, iflist, pollist, maskflag, flagrow, clip, clipminmax, clipoutside, flagmode, interactive, showflagged, outfile, outform, overwrite, plotlevel)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'sdflagold'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('sdflagold', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['infile']  = ''
        a['antenna']  = 0
        a['specunit']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['maskflag']  = []
        a['flagrow']  = []
        a['clip']  = False
        a['flagmode']  = 'flag'
        a['interactive']  = False
        a['outfile']  = ''
        a['outform']  = 'ASAP'
        a['overwrite']  = True
        a['plotlevel']  = 0

        a['specunit'] = {
                    0:{'value':''}, 
                    1:{'value':'channel'}, 
                    2:{'value':'GHz'}, 
                    3:{'value':'MHz'}, 
                    4:{'value':'kHz'}, 
                    5:{'value':'Hz'}, 
                    6:odict([{'value':'km/s'}, {'restfreq':''}])}
        a['clip'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'clipminmax':[]}, {'clipoutside':True}])}
        a['interactive'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'showflagged':False}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='sdflagold', subkey=None):
        desc={'sdflagold': 'ASAP SD spectral flagging task ',
               'infile': 'name of input SD dataset',
               'antenna': 'antenna name or id (only effective for MS input)',
               'specunit': 'units for spectral axis (channel,km/s,GHz)',
               'restfreq': 'rest frequency (default unit: Hz)',
               'frame': 'frequency reference frame, e.g. LSRK (''=current)',
               'doppler': 'doppler convention, e.g. RADIO (''=current)',
               'scanlist': 'list of scans to use and output (e.g. [1,2,3,4])',
               'field': 'string for selection by source name for flagging and output',
               'iflist': 'list of IF ids to use and output (e.g. [0,1])',
               'pollist': 'list of polarization by ids or names to use and output (e.g. [0,1])',
               'maskflag': 'list of mask regions to flag/unflag',
               'flagrow': 'list of row numbers to apply row-based flagging/unflagging',
               'clip': 'flag data outside a specified range',
               'clipminmax': 'range of data that will NOT be flagged',
               'clipoutside': 'clip outside the range, or within it',
               'flagmode': 'flag mode (flag,unflag)',
               'interactive': 'determines interactive flagging',
               'showflagged': 'show flagged data on plots',
               'outfile': 'name of output file (See a WARNING in help document)',
               'outform': 'output file format (ASCII,MS,SDFITS,ASAP) (See a WARNING in help document)',
               'overwrite': 'overwrite the output file if already exists (See a WARNING in help document)',
               'plotlevel': 'control for plotting of results',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['infile']  = ''
        a['antenna']  = 0
        a['specunit']  = ''
        a['restfreq']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['maskflag']  = []
        a['flagrow']  = []
        a['clip']  = False
        a['clipminmax']  = []
        a['clipoutside']  = True
        a['flagmode']  = 'flag'
        a['interactive']  = False
        a['showflagged']  = False
        a['outfile']  = ''
        a['outform']  = 'ASAP'
        a['overwrite']  = True
        a['plotlevel']  = 0

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['specunit']  == 'km/s':
            a['restfreq'] = ''

        if self.parameters['clip']  == True:
            a['clipminmax'] = []
            a['clipoutside'] = True

        if self.parameters['interactive']  == True:
            a['showflagged'] = False

        if a.has_key(paramname) :
	      return a[paramname]
sdflagold_cli = sdflagold_cli_()
