#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from types import * 
from task_sdplot import sdplot
class sdplot_cli_:
    __name__ = "sdplot"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (sdplot_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'infile':None, 'antenna':None, 'fluxunit':None, 'telescopeparam':None, 'specunit':None, 'restfreq':None, 'frame':None, 'doppler':None, 'field':None, 'spw':None, 'scan':None, 'pol':None, 'beam':None, 'rastermode':None, 'raster':None, 'timeaverage':None, 'tweight':None, 'scanaverage':None, 'polaverage':None, 'pweight':None, 'kernel':None, 'kwidth':None, 'plottype':None, 'stack':None, 'panel':None, 'flrange':None, 'sprange':None, 'linecat':None, 'linedop':None, 'subplot':None, 'colormap':None, 'linestyles':None, 'linewidth':None, 'histogram':None, 'center':None, 'cell':None, 'scanpattern':None, 'header':None, 'headsize':None, 'plotstyle':None, 'margin':None, 'legendloc':None, 'outfile':None, 'overwrite':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, infile=None, antenna=None, fluxunit=None, telescopeparam=None, specunit=None, restfreq=None, frame=None, doppler=None, field=None, spw=None, scan=None, pol=None, beam=None, rastermode=None, raster=None, timeaverage=None, tweight=None, scanaverage=None, polaverage=None, pweight=None, kernel=None, kwidth=None, plottype=None, stack=None, panel=None, flrange=None, sprange=None, linecat=None, linedop=None, subplot=None, colormap=None, linestyles=None, linewidth=None, histogram=None, center=None, cell=None, scanpattern=None, header=None, headsize=None, plotstyle=None, margin=None, legendloc=None, outfile=None, overwrite=None, ):

        """ASAP SD plotting task

	Detailed Description: 

Task sdplot displays single-dish spectra, total power,
or pointing direction of input data.
It assumes that the spectra have been calibrated.
It does allow selection of scans, spectral windows, polarizations, 
and some time and channel averaging/smoothing options also, but 
does not write out this data.

This task adds an additional toolbar to Matplotlib plotter. 
See the cookbook for details of its capability.
  
	Arguments :
		infile:	name of input SD dataset
		   Default Value: 

		antenna:	select an antenna name or ID, e.g. \'PM03\' (only effective for MS input)
		   Default Value: 0

		fluxunit:	units of the flux (\'\'=current)
		   Default Value: 

		telescopeparam:	parameters of telescope for flux conversion (see examples in help)
		   Default Value: 

		specunit:	units for spectral axis
		   Default Value: 
		   Allowed Values:
				
				channel
				km/s
				GHz
				MHz
				kHz
				Hz

		restfreq:	rest frequency (default unit: Hz)
		   Default Value: 

		frame:	frequency reference frame (\'\'=current)
		   Default Value: 

		doppler:	doppler convention (\'\'=current). Effective only when spw selection is in velocity unit
		   Default Value: 

		field:	select data by field IDs and names, e.g. \'3C2*\' (\'\'=all)
		   Default Value: 

		spw:	select data by IF IDs (spectral windows), e.g. \'3,5,7\' (\'\'=all)
		   Default Value: 

		scan:	select data by scan numbers, e.g. \'21~23\' (\'\'=all)
		   Default Value: 

		pol:	select data by polarization IDs, e.g. \'0,1\' (\'\'=all)
		   Default Value: 

		beam:	select data by beam IDs, e.g. \'0,1\' (\'\'=all)
		   Default Value: 

		rastermode:	mode of raster selection [\'row\', \'raster\']
		   Default Value: row
		   Allowed Values:
				row
				raster

		raster:	select data by raster scan row or map iteration e.g. \'0~2\' (\'\'=all)
		   Default Value: 

		timeaverage:	average spectra over time [True, False] (see examples in help)
		   Default Value: False

		tweight:	weighting for time averaging
		   Default Value: tintsys
		   Allowed Values:
				none
				var
				tsys
				tint
				tintsys
				median

		scanaverage:	average spectra within a scan number [True, False] (see examples in help)
		   Default Value: False

		polaverage:	average spectra over polarizations [True, False]
		   Default Value: False

		pweight:	weighting for polarization averaging
		   Default Value: tsys
		   Allowed Values:
				none
				var
				tsys

		kernel:	type of spectral smoothing
		   Default Value: 
		   Allowed Values:
				
				hanning
				gaussian
				boxcar
				none

		kwidth:	width of spectral kernel in channels
		   Default Value: 5

		plottype:	type of plot
		   Default Value: spectra
		   Allowed Values:
				pointing
				azel
				totalpower
				spectra
				grid

		stack:	code for stacking on single plot for spectral plotting
		   Default Value: p

		panel:	code for splitting into multiple panels for spectral plotting
		   Default Value: i

		flrange:	range for flux axis of plot for spectral plotting
		   Default Value: 

		sprange:	range for spectral axis of plot
		   Default Value: 

		linecat:	control for line catalog plotting for spectral plotting
		   Default Value: none

		linedop:	doppler offset for line catalog plotting (spectral plotting)
		   Default Value: 0.0

		subplot:	number of subplots (row and column)
		   Default Value: -1
		   Allowed Values:
				-1
				99

		colormap:	the colours to be used for plot lines
		   Default Value: none

		linestyles:	the linestyles to be used for plot lines
		   Default Value: none

		linewidth:	width of plotted lines
		   Default Value: 1

		histogram:	plot histogram
		   Default Value: False

		center:	the central direction of gridding. (default: map center)
		   Default Value: 

		cell:	x and y cell size, e.g., ["1arcmin","1arcmin"]. (default map extent/subplot number)
		   Default Value: 

		scanpattern:	plot scan patterns.
		   Default Value: False

		header:	print header information on the plot
		   Default Value: True

		headsize:	header fontsize
		   Default Value: 9

		plotstyle:	customize plot settings
		   Default Value: False

		margin:	subplot margins in figure coordinate
		   Default Value: 

		legendloc:	legend location
		   Default Value: 1

		outfile:	file name for hardcopy output
		   Default Value: 

		overwrite:	overwrite the output file if already exists
		   Default Value: False

	Returns: void

	Example :

Keyword arguments:
infile -- name of input SD dataset
antenna -- select an antenna name or ID
        default: 0
        example: 'PM03'
        NOTE this parameter is effective only for MS input
fluxunit -- units for line flux
        options: 'K','Jy',''
        default: '' (keep current fluxunit in data)
        WARNING: For GBT data, see description below.
    >>> fluxunit expandable parameter
        telescopeparam -- parameters of telescope for flux conversion
                options: (str) name or (list) list of gain info
                default: '' (none set)
                example: if telescopeparam='', it tries to get the telescope
                         name from the data.
                         Full antenna parameters (diameter,ap.eff.) known
                         to ASAP are
                         'ATPKSMB', 'ATPKSHOH', 'ATMOPRA', 'DSS-43',
                         'CEDUNA','HOBART'. For GBT, it fixes default fluxunit
                         to 'K' first then convert to a new fluxunit.
                         telescopeparam=[104.9,0.43] diameter(m), ap.eff.
                         telescopeparam=[0.743] gain in Jy/K
                         telescopeparam='FIX' to change default fluxunit
                         see description below
specunit -- units for spectral axis
        options: (str) 'channel','km/s','GHz','MHz','kHz','Hz'
        default: '' (=current)
        example: this will be the units for masklist
    >>> specunit expandable parameter
        restfreq -- the rest frequency
                available type includes float, int, string, list of float, 
                list of int, list of string, and list of dictionary. the 
                default unit of restfreq in case of float, int, or string 
                without unit is Hz. string input can be a value only 
                (treated as Hz) or a value followed by unit for which 'GHz',
                'MHz','kHz',and 'Hz' are available. 
                a list can be used to set different rest frequencies for 
                each IF. the length of list input must be number of IFs. 
                dictionary input should be a pair of line name and 
                frequency with keys of 'name' and 'value', respectively. 
                values in the dictionary input follows the same manner as 
                as for single float or string input. 
                example: 345.796
                         '1420MHz'
                         [345.8, 347.0, 356.7]
                         ['345.8MHz', '347.0MHz', '356.7MHz']
                         [{'name':'CO','value':345}]
frame -- frequency reference frame
        options: 'LSRK', 'TOPO', 'LSRD', 'BARY', 'GALACTO', 'LGROUP', 'CMB'
        default: '' (keep current frame in data)
doppler -- doppler convention (effective only when spw is in
           velocity unit)
        options: 'RADIO', 'OPTICAL', 'Z', 'BETA', or 'GAMMA'
        default: '' (keep current doppler setting in data)
field -- select data by field IDs and names
        default: '' (use all fields)
        example: field='3C2*' (all names starting with 3C2)
                 field='0,4,5~7' (field IDs 0,4,5,6,7)
                 field='0,3C273' (field ID 0 or field named 3C273)
        this selection is in addition to the other selections to data
spw -- select data by IF IDs (spectral windows)
       NOTE this task only supports IF ID selction and ignores channel
       selection.
        default: '' (use all IFs and channels)
        example: spw='3,5,7' (IF IDs 3,5,7; all channels)
                 spw='<2' (IF IDs less than 2, i.e., 0,1; all channels)
                 spw='30~45GHz' (IF IDs with the center frequencies in range 30-45GHz; all channels)
        this selection is in addition to the other selections to data
scan -- select data by scan numbers
        default: '' (use all scans)
        example: scan='21~23' (scan IDs 21,22,23)
        this selection is in addition to the other selections to data
pol -- select data by polarization IDs
        default: '' (use all polarizations)
        example: pol='0,1' (polarization IDs 0,1)
        this selection is in addition to the other selections to data
beam -- select data by beam IDs
        default: '' (use all beams)
        example: beam='0,1' (beam IDs 0,1)
        this selection is in addition to the other selections to data
rastermode -- mode of raster selection
        options: 'row', 'raster'
        default: 'row'
    >>> rasterrow expandable parameter
        raster -- select data by raster scan row or map iteration
        default: '' (use all data)
        example: raster='0~2'
timeaverage -- average spectra over time
        options: (bool) True, False
        default: False
    >>>timeaverage expandable parameter
        tweight -- weighting for time averaging
                options: 'var'     (1/var(spec) weighted)
                         'tsys'    (1/Tsys**2 weighted)
                         'tint'    (integration time weighted)
                         'tintsys' (Tint/Tsys**2)
                         'median'  (median averaging)
                default: 'tintsys'
        scanaverage -- average spectra within a scan number
                       when True, spectra are NOT averaged over
                       different scan numbers.
                options: (bool) True, False
                default: False
polaverage -- average spectra over polarizations
        options: (bool) True, False
        default: False
    >>>polaverage expandable parameter
        pweight -- weighting for polarization average
                options: 'var'  (1/var(spec) weighted)
                         'tsys' (1/Tsys**2 weighted)
                default: 'tsys'
kernel -- type of spectral smoothing
        options: 'hanning','gaussian','boxcar', 'none'
        default: '' (= no smoothing)
    >>>kernel expandable parameter
        kwidth -- width of spectral smoothing kernel
                options: (int) in channels
                default: 5
                example: 5 or 10 seem to be popular for boxcar
                         ignored for hanning (fixed at 5 chans)
                         (0 will turn off gaussian or boxcar)
plottype -- type of plot
        options: 'spectra','totalpower','pointing','azel','grid'
        default: 'spectra'
    >>> plottype expandable parameters
        stack -- code for stacking on single plot for spectral plotting
                options: 'p','b','i','t','s','r' or
                         'pol', 'beam', 'if', 'time', 'scan', 'row'
                default: 'p'
                example: maximum of 16 stacked spectra
                         stack by pol, beam, if, time, scan
                Note stack selection is ignored when panel='r'.
        panel -- code for splitting into multiple panels for spectral plotting
                options: 'p','b','i','t','s','r' or
                         'pol', 'beam', 'if', 'time', 'scan', 'row'
                default: 'i'
                example: maximum of 16 panels
                         panel by pol, beam, if, time, scan
                Note panel selection is ignored when stack='r'.
        flrange -- range for flux axis of plot for spectral plotting
                options: (list) [min,max]
                default: [] (full range)
                example: flrange=[-0.1,2.0] if 'K'
                         assumes current fluxunit
        sprange -- range for spectral axis of plot
                options: (list) [min,max]
                default: [] (full range)
                example: sprange=[42.1,42.5] if 'GHz'
                         assumes current specunit
        linecat -- control for line catalog plotting for spectral plotting
                options: (str) 'all','none' or by molecule
                default: 'none' (no lines plotted)
                example: linecat='SiO' for SiO lines
                         linecat='*OH' for alcohols
                         uses sprange to limit catalog
                WARNING: specunit must be in frequency (*Hz)
                         to plot from the line catalog!
                         and must be 'GHz' or 'MHz' to use
                         sprange to limit catalog
        linedop -- doppler offset for line catalog plotting (spectral plotting)
                options: (float) doppler velocity (km/s)
                default: 0.0
                example: linedop=-30.0
        center -- the central direction of gridding
                default: '' (map center)
                example: 'J2000 19h30m00 -40d00m00'
                Note currently only supports 'J2000' as direction frame
        cell -- x and y cell size of gridding
                default: [] (map extent devided by # of subplots in x and y)
                example: cell=['1.0arcmin','1.0arcmin']
                         cell='1.0arcmin' (equivalent to the example above)
                Note default number of subplots is 1 x 1 in plottype='grid'.
        subplot -- number of subplots (row and column) on a page
                NOTICE plotter will slow down when a large number is specified
                default: -1 (auto. for plottype='spectra', 1x1 for plottype='grid')
                example: 23 (2 rows by 3 columns)
        colormap -- the colours to be used for plot lines. 
                default: None
                example: colormap="green red black cyan magenta" (html standard)
                         colormap="g r k c m" (abbreviation)
                         colormap="#008000 #00FFFF #FF0090" (RGB tuple)
                         The plotter will cycle through these colours 
                         when lines are overlaid (stacking mode).
        linestyles -- the linestyles to be used for plot lines. 
                default: None
                example: linestyles="line dashed dotted dashdot dashdotdot dashdashdot". 
                         The plotter will cycle through these linestyles 
                         when lines are overlaid (stacking mode). 
                WARNING: Linestyles can be specified only one color has been set. 
        linewidth -- width of plotted lines. 
                default: 1
                example: linewidth=1 (integer)
                         linewidth=0.75 (double)
        histogram -- plot histogram
                options: (bool) True, False
                default: False
        scanpattern -- plot additional lines on the plot to indicate scan patterns
                       when plottype='pointing'
                options: (bool) True, False
                default: False
header -- print header information on the plot
        options: (bool) True, False
        default: True
        The header information is printed only on the logger when 
        plottype = 'azel' and 'pointing'. 
    >>> header expandable parameter
        headsize -- header font size
                options: (int)
                default: 9
plotstyle -- customise plot settings
        options: (bool) True, False
        default: False
    >>> plotstyle expandable parameter
        margin -- a list of subplot margins in figure coordinate (0-1), 
                  i.e., fraction of the figure width or height.
                  The order of elements should be:
                  [left, bottom, right, top, horizontal space btw panels,
                  vertical space btw panels]
                example: margin = [0.125, 0.1, 0.9, 0.9, 0.2, 0.2]
        legendloc -- legend location on the axes (0-10)
                options: (integer) 0 -10 
                         see help of "sd.plotter.set_legend" for 
                         the detail of location. Note that 0 ('best')
                         is very slow. 
                default: 1 ('upper right')
outfile -- file name for hardcopy output
        options: (str) filename.eps,.ps,.png
        default: '' (no hardcopy)
        example: 'specplot.eps','specplot.png'
        Note this autodetects the format from the suffix (.eps,.ps,.png).
overwrite -- overwrite the output file if already exists
        options: (bool) True,False
        default: False


DESCRIPTION:

Task sdplot displays single-dish spectra, total power,
or pointing direction of input data.
It assumes that the spectra have been calibrated.
It does allow selection of scans, IFs, polarizations, and
some time and channel averaging/smoothing options also,
but does not write out this data.

This task adds an additional toolbar to Matplotlib plotter. 
See the cookbook for details of its capability.

*** Data selection ***
This task allows data selection via field name, scan, IF,
polarization and beam IDs. Selection of field allows pattern
matching using asterisk, e.g., 'FLS3a*'. Selection of scans,
IFs, polarizations, and beams, is possible by a CASA type 
selection syntax using a string of comma separated numbers 
with operaters, i.e., '~', '>', and '<'.
For example, the following selection
scan = "<3,7~9,15"
is to select scan IDs 0, 1, 2, 7, 8, 9, and 15.

-------------------------------------
AVERAGING OF SPECTRA
-------------------------------------
Task sdplot has two averaging modes, i.e., time and polarization average.

When timeaverage=True, spectra are averaged over time for each IF
(spectral window), polarization, and beam, independently. Note that,
by default (scanaverage=False), timeaverage=True averages spectra
irrespective of scan IDs.
It is possible to average spectra separately for each scan ID by setting
a sub-parameter scanaverage=True.
For example, the combination of parameters: scan='0~2', timeaverage=True, and
scanaverage=False: averages spectra in scan ID 0 through 2 all together
                   to a spectrum,
scanaverage=True : averages spectra per scan ID and end up with three
                   spectra from scan 0, 1, and 2.

When polaverage=True, spectra are averaged over polarization for
each IF (spectral window) and beam. Note that, so far, time averaging is
automatically switched on when polaverage is set to True. This behavior
is not desirable and will be discarded in future.


*** available plottypes ***
* plottype = 'spectra' plots single dish spectra. Multiple scans,
  IFs, polarizations, and beams can be handles through stacking
  and panelling.
  This task uses the JPL line catalog as supplied by ASAP.
  If you wish to use a different catalog, or have it plot
  the line IDs from top or bottom (rather than alternating),
  then you will need to explore the sd toolkit also.
* plottype = 'grid' plots spectra based on their pointing direction.
  The spectra are gridded by direction before plotting.
  Multiple IFs and polarizations are not handled in this mode. Only
  the first IF and polarizaion is gridded and plotted if data 
  includes multiple IDs after selections are applied. Hence, over
  plotting is not available

Currently most of the parameters are ignored in the following modes.

* plottype='totalpower' is used to plot the total power data.
  and only plot option is amplitude versus data row number.
* plottype='azel' plots azimuth and elevation tracks of the source.
* plottype='pointing' plots antenna poinitings.

*** control of plot lines in 'spectra' and 'grid' plottype ***
Note that colormap and linestyles cannot be controlled at a time.
The 'linestyles' is ignored if both of them are specified.
Some plot options, like changing titles, legends, fonts,
and the like are not supported in this task.  You should use
sd.plotter from the ASAP toolkit directly for this.

ASAP recognizes the data of the "AT" telescopes, but currently
does not know about the GBT or any other telescope. This task
does know about GBT. Telescope name is obtained from the data.
If you wish to change the fluxunit (see below), and telescopeparam='',
for the AT telescopes it will use internal telescope parameters for
flux conversion. For GBT, it will use an approximate aperture
efficiency conversion.  If you give telescopeparam a list,
then if the list has a single float it is assumed to
be the gain in Jy/K, if two or more elements they are assumed
to be telescope diameter (m) and aperture efficiency
respectively.

WARNING: be careful plotting otf data with lots of fields!

WARNING for the GBT raw SDFITS format data as input:
SDtasks are able to handle GBT raw SDFITS format data since the 
data filler is available. However, the functionality is not well 
tested yet, so that there may be unknown bugs.  
  
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'sdplot'
        self.__globals__['taskname'] = 'sdplot'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['infile'] = infile = self.parameters['infile']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['fluxunit'] = fluxunit = self.parameters['fluxunit']
            myparams['telescopeparam'] = telescopeparam = self.parameters['telescopeparam']
            myparams['specunit'] = specunit = self.parameters['specunit']
            myparams['restfreq'] = restfreq = self.parameters['restfreq']
            myparams['frame'] = frame = self.parameters['frame']
            myparams['doppler'] = doppler = self.parameters['doppler']
            myparams['field'] = field = self.parameters['field']
            myparams['spw'] = spw = self.parameters['spw']
            myparams['scan'] = scan = self.parameters['scan']
            myparams['pol'] = pol = self.parameters['pol']
            myparams['beam'] = beam = self.parameters['beam']
            myparams['rastermode'] = rastermode = self.parameters['rastermode']
            myparams['raster'] = raster = self.parameters['raster']
            myparams['timeaverage'] = timeaverage = self.parameters['timeaverage']
            myparams['tweight'] = tweight = self.parameters['tweight']
            myparams['scanaverage'] = scanaverage = self.parameters['scanaverage']
            myparams['polaverage'] = polaverage = self.parameters['polaverage']
            myparams['pweight'] = pweight = self.parameters['pweight']
            myparams['kernel'] = kernel = self.parameters['kernel']
            myparams['kwidth'] = kwidth = self.parameters['kwidth']
            myparams['plottype'] = plottype = self.parameters['plottype']
            myparams['stack'] = stack = self.parameters['stack']
            myparams['panel'] = panel = self.parameters['panel']
            myparams['flrange'] = flrange = self.parameters['flrange']
            myparams['sprange'] = sprange = self.parameters['sprange']
            myparams['linecat'] = linecat = self.parameters['linecat']
            myparams['linedop'] = linedop = self.parameters['linedop']
            myparams['subplot'] = subplot = self.parameters['subplot']
            myparams['colormap'] = colormap = self.parameters['colormap']
            myparams['linestyles'] = linestyles = self.parameters['linestyles']
            myparams['linewidth'] = linewidth = self.parameters['linewidth']
            myparams['histogram'] = histogram = self.parameters['histogram']
            myparams['center'] = center = self.parameters['center']
            myparams['cell'] = cell = self.parameters['cell']
            myparams['scanpattern'] = scanpattern = self.parameters['scanpattern']
            myparams['header'] = header = self.parameters['header']
            myparams['headsize'] = headsize = self.parameters['headsize']
            myparams['plotstyle'] = plotstyle = self.parameters['plotstyle']
            myparams['margin'] = margin = self.parameters['margin']
            myparams['legendloc'] = legendloc = self.parameters['legendloc']
            myparams['outfile'] = outfile = self.parameters['outfile']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']

        if type(flrange)==float: flrange=[flrange]
        if type(cell)==float: cell=[cell]
        if type(margin)==float: margin=[margin]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['antenna'] = antenna
        mytmp['fluxunit'] = fluxunit
        mytmp['telescopeparam'] = telescopeparam
        mytmp['specunit'] = specunit
        mytmp['restfreq'] = restfreq
        mytmp['frame'] = frame
        mytmp['doppler'] = doppler
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['scan'] = scan
        mytmp['pol'] = pol
        mytmp['beam'] = beam
        mytmp['rastermode'] = rastermode
        mytmp['raster'] = raster
        mytmp['timeaverage'] = timeaverage
        mytmp['tweight'] = tweight
        mytmp['scanaverage'] = scanaverage
        mytmp['polaverage'] = polaverage
        mytmp['pweight'] = pweight
        mytmp['kernel'] = kernel
        mytmp['kwidth'] = kwidth
        mytmp['plottype'] = plottype
        mytmp['stack'] = stack
        mytmp['panel'] = panel
        mytmp['flrange'] = flrange
        mytmp['sprange'] = sprange
        mytmp['linecat'] = linecat
        mytmp['linedop'] = linedop
        mytmp['subplot'] = subplot
        mytmp['colormap'] = colormap
        mytmp['linestyles'] = linestyles
        mytmp['linewidth'] = linewidth
        mytmp['histogram'] = histogram
        mytmp['center'] = center
        mytmp['cell'] = cell
        mytmp['scanpattern'] = scanpattern
        mytmp['header'] = header
        mytmp['headsize'] = headsize
        mytmp['plotstyle'] = plotstyle
        mytmp['margin'] = margin
        mytmp['legendloc'] = legendloc
        mytmp['outfile'] = outfile
        mytmp['overwrite'] = overwrite
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'sdplot.xml')

        casalog.origin('sdplot')
	try :
          #if not trec.has_key('sdplot') or not casac.casac.utils().verify(mytmp, trec['sdplot']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['sdplot'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('sdplot', 'sdplot.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'sdplot'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = sdplot(infile, antenna, fluxunit, telescopeparam, specunit, restfreq, frame, doppler, field, spw, scan, pol, beam, rastermode, raster, timeaverage, tweight, scanaverage, polaverage, pweight, kernel, kwidth, plottype, stack, panel, flrange, sprange, linecat, linedop, subplot, colormap, linestyles, linewidth, histogram, center, cell, scanpattern, header, headsize, plotstyle, margin, legendloc, outfile, overwrite)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'sdplot'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('sdplot', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['infile']  = ''
        a['antenna']  = 0
        a['fluxunit']  = ''
        a['specunit']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['scan']  = ''
        a['pol']  = ''
        a['beam']  = ''
        a['rastermode']  = 'row'
        a['timeaverage']  = False
        a['polaverage']  = False
        a['kernel']  = ''
        a['plottype']  = 'spectra'
        a['header']  = True
        a['plotstyle']  = False
        a['outfile']  = ''
        a['overwrite']  = False

        a['fluxunit'] = {
                    0:{'value':''}, 
                    1:odict([{'value':'K'}, {'telescopeparam':""}]), 
                    2:odict([{'value':'k'}, {'telescopeparam':""}]), 
                    3:odict([{'value':'Jy'}, {'telescopeparam':""}]), 
                    4:odict([{'value':'jy'}, {'telescopeparam':""}])}
        a['specunit'] = {
                    0:{'value':''}, 
                    1:{'value':'channel'}, 
                    2:odict([{'value':'km/s'}, {'restfreq':''}]), 
                    3:{'value':'GHz'}, 
                    4:{'value':'MHz'}, 
                    5:{'value':'kHz'}, 
                    6:{'value':'Hz'}}
        a['rastermode'] = {
                    0:odict([{'value':'row'}, {'raster':''}]), 
                    1:odict([{'value':'raster'}, {'raster':''}])}
        a['kernel'] = {
                    0:{'value':''}, 
                    1:{'value':'hanning'}, 
                    2:odict([{'value':'gaussian'}, {'kwidth':5}]), 
                    3:odict([{'value':'boxcar'}, {'kwidth':5}]), 
                    4:{'value':'none'}}
        a['plottype'] = {
                    0:odict([{'value':'spectra'}, {'stack':'p'}, {'panel':'i'}, {'flrange':[]}, {'sprange':[]}, {'linecat':'none'}, {'linedop':0.0}, {'subplot':-1}, {'colormap':'none'}, {'linestyles':'none'}, {'linewidth':1}, {'histogram':False}]), 
                    1:odict([{'value':'grid'}, {'center':''}, {'cell':[]}, {'subplot':-1}, {'flrange':[]}, {'sprange':[]}, {'colormap':'none'}, {'linestyles':'none'}, {'linewidth':1}]), 
                    2:odict([{'value':'totalpower'}, {'stack':'p'}]), 
                    3:odict([{'value':'pointing'}, {'stack':'t'}, {'colormap':'none'}, {'scanpattern':False}]), 
                    4:{'value':'azel'}}
        a['timeaverage'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'tweight':'tintsys'}, {'scanaverage':False}])}
        a['polaverage'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'pweight':'tsys'}])}
        a['header'] = {
                    0:odict([{'value':True}, {'headsize':9}]), 
                    1:{'value':False}}
        a['plotstyle'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'margin':[]}, {'legendloc':1}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='sdplot', subkey=None):
        desc={'sdplot': 'ASAP SD plotting task',
               'infile': 'name of input SD dataset',
               'antenna': 'select an antenna name or ID, e.g. \'PM03\' (only effective for MS input)',
               'fluxunit': 'units of the flux (\'\'=current)',
               'telescopeparam': 'parameters of telescope for flux conversion (see examples in help)',
               'specunit': 'units for spectral axis [\'\',\'channel\',\'km/s\',\'GHz\',\'MHz\',\'kHz\', or \'Hz\']',
               'restfreq': 'rest frequency (default unit: Hz)',
               'frame': 'frequency reference frame (\'\'=current)',
               'doppler': 'doppler convention (\'\'=current). Effective only when spw selection is in velocity unit',
               'field': 'select data by field IDs and names, e.g. \'3C2*\' (\'\'=all)',
               'spw': 'select data by IF IDs (spectral windows), e.g. \'3,5,7\' (\'\'=all)',
               'scan': 'select data by scan numbers, e.g. \'21~23\' (\'\'=all)',
               'pol': 'select data by polarization IDs, e.g. \'0,1\' (\'\'=all)',
               'beam': 'select data by beam IDs, e.g. \'0,1\' (\'\'=all)',
               'rastermode': 'mode of raster selection [\'row\', \'raster\']',
               'raster': 'select data by raster scan row or map iteration e.g. \'0~2\' (\'\'=all)',
               'timeaverage': 'average spectra over time [True, False] (see examples in help)',
               'tweight': 'weighting for time averaging [\'tintsys\', \'tsys\', \'tint\', \'var\', or \'median\']',
               'scanaverage': 'average spectra within a scan number [True, False] (see examples in help)',
               'polaverage': 'average spectra over polarizations [True, False]',
               'pweight': 'weighting for polarization averaging [\'tsys\' or \'var\']',
               'kernel': 'type of spectral smoothing [\'hanning\',\'gaussian\', or \'boxcar\'] (\'\'=no smoothing)',
               'kwidth': 'width of spectral kernel in channels',
               'plottype': 'type of plot [\'spectra\',\'totalpower\',\'azel\',\'pointing\', or \'grid\']',
               'stack': 'setting of plot overlay [\'b\'(beam), \'i\'(spw), \'p\'(pol), \'r\'(row), \'s\'(scan), \'t\'(time or src type)]',
               'panel': 'multple panel setting [\'b\'(beam), \'i\'(spw), \'p\'(pol), \'r\'(row), \'s\'(scan), \'t\'(time)]',
               'flrange': 'range for flux axis of plot for spectral plotting',
               'sprange': 'range for spectral axis of plot',
               'linecat': 'control for line catalog plotting for spectral plotting',
               'linedop': 'doppler offset for line catalog plotting (spectral plotting)',
               'subplot': 'number of subplots (row and column)',
               'colormap': 'the colours to be used for plot lines',
               'linestyles': 'the linestyles to be used for plot lines',
               'linewidth': 'width of plotted lines',
               'histogram': 'plot histogram',
               'center': 'the central direction of gridding. (default: map center)',
               'cell': 'x and y cell size, e.g., ["1arcmin","1arcmin"]. (default map extent/subplot number)',
               'scanpattern': 'plot scan patterns.',
               'header': 'print header information on the plot',
               'headsize': 'header fontsize',
               'plotstyle': 'customize plot settings',
               'margin': 'subplot margins in figure coordinate',
               'legendloc': 'legend location',
               'outfile': 'file name for hardcopy output',
               'overwrite': 'overwrite the output file if already exists',

              }

#
# Set subfields defaults if needed
#
        if(subkey == 'totalpower'):
          desc['stack'] = 'setting of plot overlay [\'b\'(beam), \'i\'(spw), \'p\'(pol), \'r\'(row), \'s\'(scan), \'t\'(src type)]'
        if(subkey == 'pointing'):
          desc['stack'] = 'setting of plot overlay [\'b\'(beam), \'i\'(spw), \'p\'(pol), \'s\'(scan), \'t\'(src type)]'

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['infile']  = ''
        a['antenna']  = 0
        a['fluxunit']  = ''
        a['telescopeparam']  = ''
        a['specunit']  = ''
        a['restfreq']  = ''
        a['frame']  = ''
        a['doppler']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['scan']  = ''
        a['pol']  = ''
        a['beam']  = ''
        a['rastermode']  = 'row'
        a['raster']  = ''
        a['timeaverage']  = False
        a['tweight']  = 'tintsys'
        a['scanaverage']  = False
        a['polaverage']  = False
        a['pweight']  = 'tsys'
        a['kernel']  = ''
        a['kwidth']  = 5
        a['plottype']  = 'spectra'
        a['stack']  = 'p'
        a['panel']  = 'i'
        a['flrange']  = []
        a['sprange']  = []
        a['linecat']  = 'none'
        a['linedop']  = 0.0
        a['subplot']  = -1
        a['colormap']  = 'none'
        a['linestyles']  = 'none'
        a['linewidth']  = 1
        a['histogram']  = False
        a['center']  = ''
        a['cell']  = []
        a['scanpattern']  = False
        a['header']  = True
        a['headsize']  = 9
        a['plotstyle']  = False
        a['margin']  = []
        a['legendloc']  = 1
        a['outfile']  = ''
        a['overwrite']  = False

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['fluxunit']  == 'K':
            a['telescopeparam'] = ""

        if self.parameters['fluxunit']  == 'k':
            a['telescopeparam'] = ""

        if self.parameters['fluxunit']  == 'Jy':
            a['telescopeparam'] = ""

        if self.parameters['fluxunit']  == 'jy':
            a['telescopeparam'] = ""

        if self.parameters['specunit']  == 'km/s':
            a['restfreq'] = ''

        if self.parameters['rastermode']  == 'row':
            a['raster'] = ''

        if self.parameters['rastermode']  == 'raster':
            a['raster'] = ''

        if self.parameters['kernel']  == 'gaussian':
            a['kwidth'] = 5

        if self.parameters['kernel']  == 'boxcar':
            a['kwidth'] = 5

        if self.parameters['plottype']  == 'spectra':
            a['stack'] = 'p'
            a['panel'] = 'i'
            a['flrange'] = []
            a['sprange'] = []
            a['linecat'] = 'none'
            a['linedop'] = 0.0
            a['subplot'] = -1
            a['colormap'] = 'none'
            a['linestyles'] = 'none'
            a['linewidth'] = 1
            a['histogram'] = False

        if self.parameters['plottype']  == 'grid':
            a['center'] = ''
            a['cell'] = []
            a['subplot'] = -1
            a['flrange'] = []
            a['sprange'] = []
            a['colormap'] = 'none'
            a['linestyles'] = 'none'
            a['linewidth'] = 1

        if self.parameters['plottype']  == 'totalpower':
            a['stack'] = 'p'

        if self.parameters['plottype']  == 'pointing':
            a['stack'] = 't'
            a['colormap'] = 'none'
            a['scanpattern'] = False

        if self.parameters['timeaverage']  == True:
            a['tweight'] = 'tintsys'
            a['scanaverage'] = False

        if self.parameters['polaverage']  == True:
            a['pweight'] = 'tsys'

        if self.parameters['header']  == True:
            a['headsize'] = 9

        if self.parameters['plotstyle']  == True:
            a['margin'] = []
            a['legendloc'] = 1

        if a.has_key(paramname) :
	      return a[paramname]
sdplot_cli = sdplot_cli_()
