#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from types import * 
from task_sdsaveold import sdsaveold
class sdsaveold_cli_:
    __name__ = "sdsaveold"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (sdsaveold_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'infile':None, 'splitant':None, 'antenna':None, 'getpt':None, 'rowlist':None, 'scanlist':None, 'field':None, 'iflist':None, 'pollist':None, 'scanaverage':None, 'timeaverage':None, 'tweight':None, 'polaverage':None, 'pweight':None, 'restfreq':None, 'outfile':None, 'outform':None, 'overwrite':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, infile=None, splitant=None, antenna=None, getpt=None, rowlist=None, scanlist=None, field=None, iflist=None, pollist=None, scanaverage=None, timeaverage=None, tweight=None, polaverage=None, pweight=None, restfreq=None, outfile=None, outform=None, overwrite=None, ):

        """ASAP SD task: save the sd spectra in various format

	Detailed Description: 

        ASAP SD task (based on the ALMATST5 recommendations):
        save the sd spectra in various format

        Task Version 2008-01-29 TT

	Arguments :
		infile:	name of input SD dataset
		   Default Value: 

		splitant:	split output file by antenna (True,False) (only effective for MS input)
		   Default Value: False

		antenna:	antenna name or id (only effective for MS input)
		   Default Value: 0

		getpt:	fill DIRECTION column properly, or reuse POINTING table in original MS (only effective for MS input)
		   Default Value: True

		rowlist:	list of row numbers to process (e.g. [0,2,4,6])
		   Default Value: 

		scanlist:	list of scan to process (e.g. [20,21,22,23])
		   Default Value: 

		field:	string for selection by source name
		   Default Value: 

		iflist:	list of IF ids to select (e.g. [0,1])
		   Default Value: 

		pollist:	list of polarization ids to select (e.g. [0,1])
		   Default Value: 

		scanaverage:	average integs within scans (True,False) 
		   Default Value: False

		timeaverage:	average scans over time (True,False)
		   Default Value: False

		tweight:	weighting for time averaging
		   Default Value: none
		   Allowed Values:
				none
				var
				tsys
				tint
				tintsys
				median

		polaverage:	average over polarizations (True,False)
		   Default Value: False

		pweight:	
		   Default Value: none
		   Allowed Values:
				none
				var
				tsys

		restfreq:	rest frequency (default unit: Hz)
		   Default Value: 

		outfile:	output file name
		   Default Value: 

		outform:	output file format (ASCII,MS2,SDFITS,ASAP)
		   Default Value: ASAP
		   Allowed Values:
				ASCII
				MS2
				SDFITS
				ASAP

		overwrite:	overwrite the output file if already exists
		   Default Value: False

	Returns: void

	Example :

  Keyword arguments:
        infile -- name of input SD dataset
        splitant -- split output file by antenna (True,False) 
                (only effective for MS input).
                default: False
                >>>splitant expandable parameter
                 antenna -- antenna name or id (only effective for MS input). 
                         default: 0
        getpt -- fill DIRECTION column properly, or reuse POINTING table 
                in original MS (only effective for MS input)
                default: True
                options: True (fill DIRECTION column properly)
                         False (reuse POINTING table in original MS)
        rowlist -- list of row numbers to process
                default: [] (use all rows)
                example: [0,2,4,6]
                For expert users only!
                this selection is applied first, and then followed by
                the selection with scans, fields, ifs, and polarizations. 
        scanlist -- list of to process
                default: [] (use all scans)
                example: [21,22,23,24]
                this selection is in addition to field, iflist, and pollist
        field -- selection string for selecting scans by name
                default: '' (no name selection)
                example: 'FLS3a*'
                this selection is in addition to scanlist, iflist, and pollist
        iflist -- list of IF id numbers to select
                default: [] (use all IFs)
                example: [15]
                this selection is in addition to scanlist, field, and pollist
        pollist -- list of polarization id numbers to select
                default: [] (use all polarizations)
                example: [1]
                this selection is in addition to scanlist, field, and iflist
        scanaverage --  average integrations within scans
                options: (bool) True,False
                default: False
                example: if True, average integrations before it is saved
        timeaverage -- average times for multiple scan cycles
                options: (bool) True,False
                default: False
                >>>timeaverage expandable parameter
                 tweight -- weighting for time average
                         options: 'none'
                                  'var'   (1/var(spec) weighted)
                                  'tsys'  (1/Tsys**2 weighted)
                                  'tint'  (integration time weighted)
                                  'tintsys'  (Tint/Tsys**2)
                                  'median'  ( median averaging)
                         default: 'none'

        polaverage -- average polarizations
                options: (bool) True,False
                default: False
                >>>polaverage expandable parameter
                 pweight -- weighting for polarization average
                         options: 'none'
                                  'var'  (1/var(spec) weighted)
                                  'tsys' (1/Tsys**2 weighted)
        restfreq -- rest frequencies of output data
                Available types are a number, string, a list of numbers or
                strings (see examples below), and list of dictionaries. 
                The default unit of restfreq is Hz, if not specified.
                A list can be used to set different rest frequencies to
                each IF. the length of list input must be nIF. Dictionary 
                input should be a pair of molecule name and frequency with 
                keys of 'name' and 'value', respectively. The 'value's in the 
                dictionary input follows the same manner as for single 
                float or string input. 
                default: '' (use current setting)
                example: 4.6e10 (float value in Hz),
                         '46GHz' (string with unit),
                         ['345.8GHz', '347.0GHz', 356.7e9] (for each IF)
                         [{'name':'CO','value':345e9}] (a value with name)
        outfile -- name of output dataset
                default: '' 
                NOTE actual output file name(s) will be modified if splitant 
                is True as antenna names are to be included. If outfile has a 
                suffix '.asap' or '.ASAP', antenna name will be inserted before 
                the suffix like 'out.antName.asap', otherwise, antenna name 
                will be simply appended to outfile like 'out.sdfits.antName'. 
        outform -- output data format
                default: 'ASAP'
                Options: 'ASAP', 'MS2', 'SDFITS', 'ASCII'
        overwrite -- overwrite the output file if already exists
                options: (bool) True,False
                default: False
                WARNING: if outform='ASCII', this parameter is ignored


        DESCRIPTION:

        Task sdsaveold writes the single dish data to a disk file in 
        specified format (ASAP, MS2, SDFITS, ASCII). It is possible to 
        save the subset of the data by selecting row numbers, scan numbers, 
        IF ids, polarization ids and field names. The ASAP (scantable) format 
        is recommended for further analysis using Sd tool. For further 
        imaging using imager, save the data to the Measurement Set (MS2).

        Note that setting getpt=False needs a lot of attention.
        If you set getpt=False, the task retrieves pointing direction from 
        MS's FIELD table, which might not be correct for single dish 
        observation, instead to check MS's POINTING table, which is the 
        default behavior of the task (getpt=True). To compensate this, 
        absolute path to MS's POINTING table is stored, and it will be used 
        for POINTING table when the data is converted back to MS format. 
        In general, getpt=False is faster especially for large data. However, 
        MS created from Scantable cannot have correct POINTING table if 
        original MS's POINTING table doesn't exist. Such situation will 
        happen when original MS is removed or renamed, or imported Scantable 
        is moved to other computer alone.

        WARNING for the GBT raw SDFITS format data as input:
        SDtasks are able to handle GBT raw SDFITS format data since the 
        data filler is available. However, the functionality is not well 
        tested yet, so that there may be unknown bugs.  

  
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'sdsaveold'
        self.__globals__['taskname'] = 'sdsaveold'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['infile'] = infile = self.parameters['infile']
            myparams['splitant'] = splitant = self.parameters['splitant']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['getpt'] = getpt = self.parameters['getpt']
            myparams['rowlist'] = rowlist = self.parameters['rowlist']
            myparams['scanlist'] = scanlist = self.parameters['scanlist']
            myparams['field'] = field = self.parameters['field']
            myparams['iflist'] = iflist = self.parameters['iflist']
            myparams['pollist'] = pollist = self.parameters['pollist']
            myparams['scanaverage'] = scanaverage = self.parameters['scanaverage']
            myparams['timeaverage'] = timeaverage = self.parameters['timeaverage']
            myparams['tweight'] = tweight = self.parameters['tweight']
            myparams['polaverage'] = polaverage = self.parameters['polaverage']
            myparams['pweight'] = pweight = self.parameters['pweight']
            myparams['restfreq'] = restfreq = self.parameters['restfreq']
            myparams['outfile'] = outfile = self.parameters['outfile']
            myparams['outform'] = outform = self.parameters['outform']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']

        if type(rowlist)==int: rowlist=[rowlist]
        if type(scanlist)==int: scanlist=[scanlist]
        if type(iflist)==int: iflist=[iflist]
        if type(pollist)==int: pollist=[pollist]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['splitant'] = splitant
        mytmp['antenna'] = antenna
        mytmp['getpt'] = getpt
        mytmp['rowlist'] = rowlist
        mytmp['scanlist'] = scanlist
        mytmp['field'] = field
        mytmp['iflist'] = iflist
        mytmp['pollist'] = pollist
        mytmp['scanaverage'] = scanaverage
        mytmp['timeaverage'] = timeaverage
        mytmp['tweight'] = tweight
        mytmp['polaverage'] = polaverage
        mytmp['pweight'] = pweight
        mytmp['restfreq'] = restfreq
        mytmp['outfile'] = outfile
        mytmp['outform'] = outform
        mytmp['overwrite'] = overwrite
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'sdsaveold.xml')

        casalog.origin('sdsaveold')
	try :
          #if not trec.has_key('sdsaveold') or not casac.casac.utils().verify(mytmp, trec['sdsaveold']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['sdsaveold'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('sdsaveold', 'sdsaveold.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'sdsaveold'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = sdsaveold(infile, splitant, antenna, getpt, rowlist, scanlist, field, iflist, pollist, scanaverage, timeaverage, tweight, polaverage, pweight, restfreq, outfile, outform, overwrite)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'sdsaveold'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('sdsaveold', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['infile']  = ''
        a['splitant']  = False
        a['getpt']  = True
        a['rowlist']  = []
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['scanaverage']  = False
        a['timeaverage']  = False
        a['polaverage']  = False
        a['restfreq']  = ''
        a['outfile']  = ''
        a['outform']  = 'ASAP'
        a['overwrite']  = False

        a['splitant'] = {
                    0:odict([{'value':False}, {'antenna':0}]), 
                    1:{'value':True}}
        a['timeaverage'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'tweight':'none'}])}
        a['polaverage'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'pweight':'none'}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='sdsaveold', subkey=None):
        desc={'sdsaveold': 'ASAP SD task: save the sd spectra in various format',
               'infile': 'name of input SD dataset',
               'splitant': 'split output file by antenna (True,False) (only effective for MS input)',
               'antenna': 'antenna name or id (only effective for MS input)',
               'getpt': 'fill DIRECTION column properly, or reuse POINTING table in original MS (only effective for MS input)',
               'rowlist': 'list of row numbers to process (e.g. [0,2,4,6])',
               'scanlist': 'list of scan to process (e.g. [20,21,22,23])',
               'field': 'string for selection by source name',
               'iflist': 'list of IF ids to select (e.g. [0,1])',
               'pollist': 'list of polarization ids to select (e.g. [0,1])',
               'scanaverage': 'average integs within scans (True,False) ',
               'timeaverage': 'average scans over time (True,False)',
               'tweight': 'weighting for time averaging',
               'polaverage': 'average over polarizations (True,False)',
               'pweight': '',
               'restfreq': 'rest frequency (default unit: Hz)',
               'outfile': 'output file name',
               'outform': 'output file format (ASCII,MS2,SDFITS,ASAP)',
               'overwrite': 'overwrite the output file if already exists',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['infile']  = ''
        a['splitant']  = False
        a['antenna']  = 0
        a['getpt']  = True
        a['rowlist']  = []
        a['scanlist']  = []
        a['field']  = ''
        a['iflist']  = []
        a['pollist']  = []
        a['scanaverage']  = False
        a['timeaverage']  = False
        a['tweight']  = 'none'
        a['polaverage']  = False
        a['pweight']  = 'none'
        a['restfreq']  = ''
        a['outfile']  = ''
        a['outform']  = 'ASAP'
        a['overwrite']  = False

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['splitant']  == False:
            a['antenna'] = 0

        if self.parameters['timeaverage']  == True:
            a['tweight'] = 'none'

        if self.parameters['polaverage']  == True:
            a['pweight'] = 'none'

        if a.has_key(paramname) :
	      return a[paramname]
sdsaveold_cli = sdsaveold_cli_()
