#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_tclean import tclean
from task_tclean import casalog

class tclean_pg_:
    __name__ = "tclean"

    def __init__(self) :
       self.__bases__ = (tclean_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,field=None,spw=None,timerange=None,uvrange=None,antenna=None,scan=None,observation=None,intent=None,datacolumn=None,imagename=None,imsize=None,cell=None,phasecenter=None,stokes=None,projection=None,startmodel=None,outlierfile=None,overwrite=None,specmode=None,reffreq=None,nchan=None,start=None,width=None,outframe=None,veltype=None,restfreq=None,sysvel=None,sysvelframe=None,interpolation=None,gridmode=None,facets=None,wprojplanes=None,aterm=None,psterm=None,wbawp=None,conjbeams=None,cfcache=None,computepastep=None,rotatepastep=None,pblimit=None,normtype=None,weighting=None,robust=None,npixels=None,uvtaper=None,deconvolver=None,scales=None,ntaylorterms=None,restoringbeam=None,niter=None,gain=None,threshold=None,cycleniter=None,cyclefactor=None,minpsffraction=None,maxpsffraction=None,interactive=None,mask=None,savemodel=None,recalcres=None,recalcpsf=None,parallel=None,):

        """Construct and deconvolve images

      (Refactored) Imaging task.  Documentation to come.... 

      Missing parameters and functions : post-deconvolution pbcor.

  
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'tclean'
        myf['taskname'] = 'tclean'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['field'] = field = myf['field']
            myparams['spw'] = spw = myf['spw']
            myparams['timerange'] = timerange = myf['timerange']
            myparams['uvrange'] = uvrange = myf['uvrange']
            myparams['antenna'] = antenna = myf['antenna']
            myparams['scan'] = scan = myf['scan']
            myparams['observation'] = observation = myf['observation']
            myparams['intent'] = intent = myf['intent']
            myparams['datacolumn'] = datacolumn = myf['datacolumn']
            myparams['imagename'] = imagename = myf['imagename']
            myparams['imsize'] = imsize = myf['imsize']
            myparams['cell'] = cell = myf['cell']
            myparams['phasecenter'] = phasecenter = myf['phasecenter']
            myparams['stokes'] = stokes = myf['stokes']
            myparams['projection'] = projection = myf['projection']
            myparams['startmodel'] = startmodel = myf['startmodel']
            myparams['outlierfile'] = outlierfile = myf['outlierfile']
            myparams['overwrite'] = overwrite = myf['overwrite']
            myparams['specmode'] = specmode = myf['specmode']
            myparams['reffreq'] = reffreq = myf['reffreq']
            myparams['nchan'] = nchan = myf['nchan']
            myparams['start'] = start = myf['start']
            myparams['width'] = width = myf['width']
            myparams['outframe'] = outframe = myf['outframe']
            myparams['veltype'] = veltype = myf['veltype']
            myparams['restfreq'] = restfreq = myf['restfreq']
            myparams['sysvel'] = sysvel = myf['sysvel']
            myparams['sysvelframe'] = sysvelframe = myf['sysvelframe']
            myparams['interpolation'] = interpolation = myf['interpolation']
            myparams['gridmode'] = gridmode = myf['gridmode']
            myparams['facets'] = facets = myf['facets']
            myparams['wprojplanes'] = wprojplanes = myf['wprojplanes']
            myparams['aterm'] = aterm = myf['aterm']
            myparams['psterm'] = psterm = myf['psterm']
            myparams['wbawp'] = wbawp = myf['wbawp']
            myparams['conjbeams'] = conjbeams = myf['conjbeams']
            myparams['cfcache'] = cfcache = myf['cfcache']
            myparams['computepastep'] = computepastep = myf['computepastep']
            myparams['rotatepastep'] = rotatepastep = myf['rotatepastep']
            myparams['pblimit'] = pblimit = myf['pblimit']
            myparams['normtype'] = normtype = myf['normtype']
            myparams['weighting'] = weighting = myf['weighting']
            myparams['robust'] = robust = myf['robust']
            myparams['npixels'] = npixels = myf['npixels']
            myparams['uvtaper'] = uvtaper = myf['uvtaper']
            myparams['deconvolver'] = deconvolver = myf['deconvolver']
            myparams['scales'] = scales = myf['scales']
            myparams['ntaylorterms'] = ntaylorterms = myf['ntaylorterms']
            myparams['restoringbeam'] = restoringbeam = myf['restoringbeam']
            myparams['niter'] = niter = myf['niter']
            myparams['gain'] = gain = myf['gain']
            myparams['threshold'] = threshold = myf['threshold']
            myparams['cycleniter'] = cycleniter = myf['cycleniter']
            myparams['cyclefactor'] = cyclefactor = myf['cyclefactor']
            myparams['minpsffraction'] = minpsffraction = myf['minpsffraction']
            myparams['maxpsffraction'] = maxpsffraction = myf['maxpsffraction']
            myparams['interactive'] = interactive = myf['interactive']
            myparams['mask'] = mask = myf['mask']
            myparams['savemodel'] = savemodel = myf['savemodel']
            myparams['recalcres'] = recalcres = myf['recalcres']
            myparams['recalcpsf'] = recalcpsf = myf['recalcpsf']
            myparams['parallel'] = parallel = myf['parallel']

        if type(uvtaper)==str: uvtaper=[uvtaper]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['timerange'] = timerange
        mytmp['uvrange'] = uvrange
        mytmp['antenna'] = antenna
        mytmp['scan'] = scan
        mytmp['observation'] = observation
        mytmp['intent'] = intent
        mytmp['datacolumn'] = datacolumn
        mytmp['imagename'] = imagename
        mytmp['imsize'] = imsize
        mytmp['cell'] = cell
        mytmp['phasecenter'] = phasecenter
        mytmp['stokes'] = stokes
        mytmp['projection'] = projection
        mytmp['startmodel'] = startmodel
        mytmp['outlierfile'] = outlierfile
        mytmp['overwrite'] = overwrite
        mytmp['specmode'] = specmode
        mytmp['reffreq'] = reffreq
        mytmp['nchan'] = nchan
        mytmp['start'] = start
        mytmp['width'] = width
        mytmp['outframe'] = outframe
        mytmp['veltype'] = veltype
        mytmp['restfreq'] = restfreq
        mytmp['sysvel'] = sysvel
        mytmp['sysvelframe'] = sysvelframe
        mytmp['interpolation'] = interpolation
        mytmp['gridmode'] = gridmode
        mytmp['facets'] = facets
        mytmp['wprojplanes'] = wprojplanes
        mytmp['aterm'] = aterm
        mytmp['psterm'] = psterm
        mytmp['wbawp'] = wbawp
        mytmp['conjbeams'] = conjbeams
        mytmp['cfcache'] = cfcache
        mytmp['computepastep'] = computepastep
        mytmp['rotatepastep'] = rotatepastep
        mytmp['pblimit'] = pblimit
        mytmp['normtype'] = normtype
        mytmp['weighting'] = weighting
        mytmp['robust'] = robust
        mytmp['npixels'] = npixels
        mytmp['uvtaper'] = uvtaper
        mytmp['deconvolver'] = deconvolver
        mytmp['scales'] = scales
        mytmp['ntaylorterms'] = ntaylorterms
        mytmp['restoringbeam'] = restoringbeam
        mytmp['niter'] = niter
        mytmp['gain'] = gain
        mytmp['threshold'] = threshold
        mytmp['cycleniter'] = cycleniter
        mytmp['cyclefactor'] = cyclefactor
        mytmp['minpsffraction'] = minpsffraction
        mytmp['maxpsffraction'] = maxpsffraction
        mytmp['interactive'] = interactive
        mytmp['mask'] = mask
        mytmp['savemodel'] = savemodel
        mytmp['recalcres'] = recalcres
        mytmp['recalcpsf'] = recalcpsf
        mytmp['parallel'] = parallel
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'tclean.xml')

        casalog.origin('tclean')
        if not trec.has_key('tclean') or not casac.utils().verify(mytmp, trec['tclean']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: tclean           #####')
          casalog.post('')
          result = tclean(vis, field, spw, timerange, uvrange, antenna, scan, observation, intent, datacolumn, imagename, imsize, cell, phasecenter, stokes, projection, startmodel, outlierfile, overwrite, specmode, reffreq, nchan, start, width, outframe, veltype, restfreq, sysvel, sysvelframe, interpolation, gridmode, facets, wprojplanes, aterm, psterm, wbawp, conjbeams, cfcache, computepastep, rotatepastep, pblimit, normtype, weighting, robust, npixels, uvtaper, deconvolver, scales, ntaylorterms, restoringbeam, niter, gain, threshold, cycleniter, cyclefactor, minpsffraction, maxpsffraction, interactive, mask, savemodel, recalcres, recalcpsf, parallel)
          casalog.post('')
          casalog.post('##### End Task: tclean           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('tclean', 'tclean.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'tclean'
	     casalog.post('An error occurred running task '+tname+'.', 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('tclean', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['imagename']  = ''
        a['outlierfile']  = ''
        a['overwrite']  = True
        a['specmode']  = 'mfs'
        a['gridmode']  = 'standard'
        a['weighting']  = 'natural'
        a['deconvolver']  = 'clark'
        a['niter']  = 500
        a['savemodel']  = '"none"'
        a['recalcres']  = True
        a['recalcpsf']  = True
        a['parallel']  = False

        a['vis'] = {
                    0:odict([{'notvalue':''}, {'field':""}, {'spw':""}, {'timerange':""}, {'uvrange':""}, {'antenna':""}, {'scan':""}, {'observation':""}, {'intent':""}, {'datacolumn':"corrected"}])}
        a['imagename'] = {
                    0:odict([{'notvalue':''}, {'imsize':100}, {'cell':"1arcsec"}, {'phasecenter':""}, {'stokes':"I"}, {'projection':"SIN"}, {'startmodel':""}])}
        a['specmode'] = {
                    0:odict([{'value':'mfs'}, {'reffreq':""}]), 
                    1:odict([{'value':'cube'}, {'nchan':-1}, {'start':""}, {'width':""}, {'outframe':""}, {'veltype':"radio"}, {'restfreq':[]}, {'interpolation':"linear"}]), 
                    2:odict([{'value':'cubesrc'}, {'nchan':-1}, {'start':""}, {'width':""}, {'outframe':""}, {'veltype':"radio"}, {'restfreq':[]}, {'sysvel':""}, {'sysvelframe':""}, {'interpolation':"linear"}]), 
                    3:odict([{'value':'cubedata'}, {'nchan':-1}, {'start':""}, {'width':""}, {'veltype':"radio"}, {'restfreq':[]}, {'interpolation':"linear"}])}
        a['gridmode'] = {
                    0:{'value':'standard'}, 
                    1:odict([{'value':'widefield'}, {'wprojplanes':1}, {'facets':1}]), 
                    2:odict([{'value':'mosaic'}, {'pblimit':0.01}, {'normtype':"flatnoise"}]), 
                    3:odict([{'value':'imagemosaic'}, {'wprojplanes':1}, {'pblimit':0.01}, {'normtype':"flatnoise"}]), 
                    4:odict([{'value':'awproject'}, {'wprojplanes':1}, {'pblimit':0.01}, {'normtype':"flatnoise"}, {'psterm':False}, {'cfcache':""}, {'computepastep':360.0}, {'rotatepastep':5.0}, {'wbawp':False}, {'conjbeams':False}])}
        a['weighting'] = {
                    0:odict([{'value':'natural'}, {'uvtaper':[]}]), 
                    1:{'value':'uniform'}, 
                    2:odict([{'value':'briggs'}, {'robust':0.5}, {'npixels':0}, {'uvtaper':[]}])}
        a['deconvolver'] = {
                    0:odict([{'value':'clark'}, {'restoringbeam':[]}]), 
                    1:odict([{'value':'hogbom'}, {'restoringbeam':[]}]), 
                    2:odict([{'value':'multiscale'}, {'scales':[]}, {'restoringbeam':[]}]), 
                    3:odict([{'value':'mtmfs'}, {'scales':[]}, {'ntaylorterms':1}, {'restoringbeam':[]}]), 
                    4:odict([{'value':'aasp'}, {'restoringbeam':[]}])}
        a['niter'] = {
                    0:odict([{'notvalue':0}, {'gain':0.1}, {'threshold':0.0}, {'cycleniter':-1}, {'cyclefactor':1.0}, {'minpsffraction':0.05}, {'maxpsffraction':0.8}, {'interactive':False}, {'mask':""}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='tclean', subkey=None):
        desc={'tclean': 'Construct and deconvolve images',
               'vis': 'Name of input visibility file(s)',
               'field': 'field(s) to select',
               'spw': 'spw(s) to select',
               'timerange': 'Range of time to select from data',
               'uvrange': 'Select data within uvrange ',
               'antenna': 'Select data based on antenna/baseline',
               'scan': 'Scan number range',
               'observation': 'Observation ID range',
               'intent': 'Scan Intent(s)',
               'datacolumn': 'data or observed, corrected',
               'imagename': 'Pre-name of output images',
               'imsize': 'Number of pixels',
               'cell': 'Cell size',
               'phasecenter': 'Phase center of the image',
               'stokes': 'Stokes Planes to make',
               'projection': 'Coordinate projection (SIN, HPX) ',
               'startmodel': 'Name of starting model image ',
               'outlierfile': 'Name of outlier-field image definitions',
               'overwrite': 'True : Re-use existing images. False : Increment imagename',
               'specmode': 'Spectral definition mode (mfs,cube,cubesrc,cubedata)',
               'reffreq': 'Reference frequency',
               'nchan': 'Number of channels in the output image',
               'start': 'First channel (e.g. chan=3,chan=\'1.1GHz\',chan=\'15343km/s\')',
               'width': 'Channel width (e.g. width=2,width=\'0.1MHz\',width=\'10km/s\')',
               'outframe': 'Spectral reference frame in which to interpret \'start\' and \'width\'',
               'veltype': 'Velocity type (radio, z, ratio, beta, gamma, optical)',
               'restfreq': 'List of rest frequencies',
               'sysvel': 'Systemic velocity (for mode=cubesrc) ',
               'sysvelframe': 'Spectral frame in which sysvel is specified (for mode=cubesrc only)',
               'interpolation': 'Spectral interpolation (nearest,linear,cubic)',
               'gridmode': 'Gridding options (standard, widefield, mosaic, imagemosaic, awproject)',
               'facets': 'Number of facets on a side',
               'wprojplanes': 'Number of w-planes for convolution function calculation',
               'aterm': 'Use aperture illumination function during gridding',
               'psterm': 'Use prolate spheroidal during gridding',
               'wbawp': 'Use wideband A-terms',
               'conjbeams': 'Use conjugate frequency for wideband A-terms ',
               'cfcache': 'Convolution function cache directory name',
               'computepastep': 'At what parallactic angle interval to recompute AIFs (deg) ',
               'rotatepastep': 'At what parallactic angle interval to rotate nearest AIF (deg) ',
               'pblimit': 'PB gain level at which to cut off image calculations  ',
               'normtype': 'Normalization type (flatnoise, flatsky) ',
               'weighting': 'Weighting scheme (natural,uniform,briggs)',
               'robust': 'Robustness parameter',
               'npixels': 'Number of pixels to determine uv-cell size (0 : -/+ 3 pixels)',
               'uvtaper': 'uv-taper on outer baselines in uv-plane',
               'deconvolver': 'Name of minor cycle algorithm',
               'scales': 'List of scale sizes (in pixels) for multi-scale cleaning',
               'ntaylorterms': 'Number of Taylor coefficients in the spectral model',
               'restoringbeam': 'Restoring beam shape to use. Default is the PSF main lobe width. ',
               'niter': 'Maximum number of iterations',
               'gain': 'Loop gain',
               'threshold': 'Stopping threshold (number, in units of Jy)',
               'cycleniter': 'Maximum number of minor-cycle iterations before triggering a major cycle',
               'cyclefactor': 'Scaling on PSF sidelobe level to compute the minor-cycle stopping threshold.',
               'minpsffraction': 'PSF fraction that marks the max depth of cleaning in the minor cycle ',
               'maxpsffraction': 'PSF fraction that marks the minimum depth of cleaning in the minor cycle ',
               'interactive': 'True to be able to modify masks and parameters at runtime',
               'mask': 'Mask string (image name or region file or region string)',
               'savemodel': 'Options to save model at the end (none, virtual, modelcolumn)',
               'recalcres': '(Re)calculate residual image',
               'recalcpsf': 'Recalculate PSF',
               'parallel': 'Run major cycles in parallel',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['timerange']  = ''
        a['uvrange']  = ''
        a['antenna']  = ''
        a['scan']  = ''
        a['observation']  = ''
        a['intent']  = ''
        a['datacolumn']  = 'corrected'
        a['imagename']  = ''
        a['imsize']  = [100]
        a['cell']  = ["1arcsec"]
        a['phasecenter']  = ''
        a['stokes']  = 'I'
        a['projection']  = 'SIN'
        a['startmodel']  = ''
        a['outlierfile']  = ''
        a['overwrite']  = True
        a['specmode']  = 'mfs'
        a['reffreq']  = ''
        a['nchan']  = -1
        a['start']  = ''
        a['width']  = ''
        a['outframe']  = 'LSRK'
        a['veltype']  = 'radio'
        a['restfreq']  = []
        a['sysvel']  = ''
        a['sysvelframe']  = ''
        a['interpolation']  = 'linear'
        a['gridmode']  = 'standard'
        a['facets']  = 1
        a['wprojplanes']  = 1
        a['aterm']  = True
        a['psterm']  = False
        a['wbawp']  = True
        a['conjbeams']  = True
        a['cfcache']  = ''
        a['computepastep']  = 360.0
        a['rotatepastep']  = 5.0
        a['pblimit']  = 0.01
        a['normtype']  = 'flatnoise'
        a['weighting']  = 'natural'
        a['robust']  = 0.5
        a['npixels']  = 0
        a['uvtaper']  = ['']
        a['deconvolver']  = 'clark'
        a['scales']  = []
        a['ntaylorterms']  = 1
        a['restoringbeam']  = []
        a['niter']  = 500
        a['gain']  = 0.1
        a['threshold']  = 0.0
        a['cycleniter']  = -1
        a['cyclefactor']  = 1.0
        a['minpsffraction']  = 0.05
        a['maxpsffraction']  = 0.8
        a['interactive']  = False
        a['mask']  = ''
        a['savemodel']  = '"none"'
        a['recalcres']  = True
        a['recalcpsf']  = True
        a['parallel']  = False

        if a.has_key(paramname) :
	      return a[paramname]
tclean_pg = tclean_pg_()
